<?php
/**
* @version		$Id: tpjobs.php 1.0$
* @package		Joomla
* @subpackage	TPJobs
* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/
// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.helper');
require_once(JApplicationHelper::getPath('html'));
JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_tpjobs'.DS.'tables');

if (!function_exists('call_css_com_tpjobs')) {	
	function call_css_com_tpjobs() {
		$document = & JFactory::getDocument(); 
		$document->addCustomTag('<link rel="stylesheet" type="text/css" href="'. JURI::base() . 'components/com_tpjobs/css/style.css"/>'); 	
	}
	call_css_com_tpjobs();

} 

if($task != 'invoice')
	HTML_front_tpjobs::showMenu($option);

$user	=& JFactory::getUser();

switch($task)
{
	//EMPLOYER
	case 'regemployer':
		if(isEmployer($user->id))
		{
			$return	= JRoute::_('index.php?option=com_tpjobs');
			$mainframe->redirect( $return );	
			return;
		}
		editEmployer(false);
	break;
	
	case 'editemployer':
		editEmployer(true);
	break;
	
	case 'saveemployer':
		saveEmployer($option);
	break;
	
	case 'regemployernew':
		regEmployerNew($option);
	break;
	
	case 'saveemployernew':
		saveEmployerNew($option);
	break;
	
	case 'billing':
		showBilling($option);
	break;
	
	case 'buycredit':
		buyCredit($option);
	break;
	
	case 'savebuycredit':
		saveBuyCredit($option);
	break;
	
	case 'manualpayment':
		manualPayment($option);
	break;
	
	case 'paypalpayment':
		require_once(JPATH_COMPONENT.DS.'paypal.class.php');	
		paypalPayment($option);
	break;
	
	case 'returnpaypal':
		returnPaypal($option);
	break;
	
	case 'cancelpayment':
		cancelPayment($option);
	break;

	case 'postjob':
		editJob(false);
	break;
	
	case 'joblist':
		jobList($option);
	break;
	
	case 'yourjoblist':
		showJob($option);
	break;
		
	case 'editjob':
		editJob(true);
	break;	
	
	case 'savejob':
		saveJob($option);
	break;
		
	case 'editjob':
		editJob(true);
	break;	
	
	case 'publishjob':
		publishJob($option);
	break;
		
	case 'savepublishjob':
		savePublishJob($option);
	break;
	
	case 'credit':
		showCredit($option);
	break;
	
	case 'findresume':
		findResume($option);
	break;
	
	case 'buypacket':
		buyPacket($option);
	break;
		
	case 'viewbuypacket':
		viewBuyPacket($option);
	break;
		
	case 'savebuypacket':
		saveBuyPacket($option);
	break;
	
	//JOBSEEKER
	case 'regjobseeker':
		editJobSeeker(false);
	break;
	
	case 'editjobseeker':
		editJobSeeker(true);
	break;
	
	case 'savejobseeker':
		saveJobSeeker($option);
	break;	
	
	case 'regjobseekernew':
		regJobSeekerNew(false);
	break;
	
	case 'savejobseekernew':
		saveJobSeekerNew($option);
	break;
	
	case 'postresume':
		editResume(false);
	break;
	
	case 'editresume':
		editResume(true);
	break;
	
	case 'viewresume':
		viewResume(true);
	break;
	
	case 'removeresume':
		removeResume(true);
	break;
	
	case 'saveresume':
		saveResume($option);
	break;
	
	case 'savejobbyjs':
		applyJobByJS(false);
	break;
	
	case 'applyjobbyjs':
		applyJobByJS(true);
	break;
	
	case 'mysavedjob':
		mySavedJob($option);
	break;
	
	case 'delsavedjob':
		deleteSaveJob($option);
	break;
	
	case 'delallsavedjob':
		deleteAllSaveJob($option);
	break;
	
	
	//JOBSEEKER AND EMPLOYER & GUEST
	case 'simplesearch':
		simpleSearch($option);
	break;
	
	case 'searchbyspec':
		searchBySpec($option);
	break;
	
	case 'searchbyloc':
		searchByLoc($option);
	break;
	
	case 'searchbypos':
		searchByPos($option);
	break;
	
	case 'searchbyind':
		searchByInd($option);
	break;
	
	case 'detailjob':
		detailJob($option);
	break;
	
	case 'detailcomp':
		detailCompany($option);
	break;
	
	case 'detailjobseeker':
		detailJobSeeker($option);
	break;
	
	case 'advsearch':
		advSearch($option);
	break;
	
	case 'resadvsearch':
		resAdvSearch($option);
	break;

	case 'invoice':
		invoice($option);
	break;
	
	case 'simplesearchform':
		HTML_front_tpjobs::simpleSearchForm($option);
	break;
	
	//FRONT MENU
	default:
		showFront($option);
	break;	
	
}


function showFront($option)
{
	$user	=& JFactory::getUser();
	if(!$user->id OR (!isJobSeeker($user->id) && !isEmployer($user->id)))
	{
		$db =& JFactory::getDBO();
		$query = "SELECT content FROM #__tpjobs_text WHERE name='FOR_EMPLOYER'";
		$db->setQuery($query);
		$textforemployer = $db->loadResult();
	
		$query = "SELECT content FROM #__tpjobs_text WHERE name='FOR_JOBSEEKER'";
		$db->setQuery($query);
		$textforjobseeker = $db->loadResult();
		HTML_front_tpjobs::showFront($textforemployer, $textforjobseeker, $option);
	}
	else
	{
		jobList( $option );
	}
}




/**	
==================================================================================================================	
	SECTION : Employer
	1.Employer
	2.Billing
	3.showCredit
	4.Buy Credit
	5.Save Buy Credit
	6.Manual Payment
	7.edit Job
	8.Publish Job
	9.SavePublish Job
	10.findResume
	
==================================================================================================================
*/

//editEmployer
function editEmployer($edit)
{
	global $mainframe, $option;
	$user	=& JFactory::getUser();
	if(isJobSeeker($user->id))
	{
		$return	= JRoute::_('index.php?option=com_tpjobs');
		$mainframe->redirect( $return );	
		return;
	}
	
	$db		=& JFactory::getDBO();
	
	if($user->id == 0){
		$return	= JRoute::_('index.php?option=com_user&view=login');
		$mainframe->redirect( $return );	
	}
	
	$row =& JTable::getInstance('employer','Table');
	
	if($edit){
		$query = "select id from #__tpjobs_employer where user_id =".$user->id;	
		$db->setQuery( $query );
		$id_employer = $db->loadResult();
		$row->load($id_employer);
	}
	HTML_front_tpjobs::regEmployer($row,$option);
}


//saveEmployer
function saveEmployer($option)
{
	global $mainframe;
	$user	=& JFactory::getUser();
	
	// Check for request forgeries
	JRequest::checkToken() or jexit('Invalid Token');
	
	// Initialize variables
	$db		=& JFactory::getDBO();
	$row	=& JTable::getInstance('employer', 'Table');
	$post   = JRequest::get('post');

	$post['name'] = (!empty($post['firstname'])) ? $post['firstname'] : null;
	$post['name'] .= (!empty($post['name']) && !empty($post['lastname'])) ? ' ' . $post['lastname'] : null;
	
	$id = (!empty($post['id'])) ? (int)$post['id'] : 0;
	if(!empty($id) && !empty($post['name']))
	{
		$query = "UPDATE #__users SET name='".$post['name']."' WHERE id='".$user->id."'";
		$db->setQuery($query);
		$db->query();
	}

	$row->user_id = $user->id;
	
	if (!$row->bind( $post )) {
		JError::raiseError(500, $row->getError() );
	}
	
	// pre-save checks
	if (!$row->check()) {
		JError::raiseError(500, $row->getError() );
	}
	
	// if new item,  last in appropriate group
	if (!$row->id) {
		$where = "id = " . (int) $row->id;		
	}
	
	// save the changes
	if (!$row->store()) {
		JError::raiseError(500, $row->getError() );
	}
	
	$row->checkin();
	//give bonus signup
	if($id ==0){
		$config = & JComponentHelper::getParams('com_tpjobs');	
		$minimum_credit = $config->get('bonus_signup_emp');

		$date_trans  = date('Y-m-d H:i:s', time() + ( $mainframe->getCfg('offset') * 60 * 60 ) );
		$trans = & JTable::getInstance('transaction','Table');
		$trans->date_trans =$date_trans;
		$trans->transaction ="Bonus for registration as employer";	
		$trans->credit_plus = $minimum_credit;
		$trans->employer_id = $user->id;
		
		// pre-save checks
		if (!$trans->check()) {
			JError::raiseError(500, $trans->getError() );
		}
		// save the changes
		if (!$trans->store()) {
			JError::raiseError(500, $trans->getError() );
		}
		$trans->checkin();
	}
	
	if(!empty($_FILES['photo']))
	{
		tpjobsUploadPhoto($_FILES['photo'], $row->user_id);
	}
	
	$link	= JRoute::_('index.php?option=com_tpjobs');	
	$mainframe->redirect( JRoute::_($link));
}

//Billing
function showBilling($option)
{
	global $mainframe;
	$user	=& JFactory::getUser();
	$db		=& JFactory::getDBO();
	
	$is_employer = isEmployer($user->id);
	
	if($user->id == 0){
		$return	= JRoute::_('index.php?option=com_user&view=login');
		$mainframe->redirect( $return );	
	}
	
	if($is_employer == 0){
		$return	= JRoute::_('index.php?option=com_tpjobs&task=regemployer');
		$mainframe->redirect( $return );	
	}
	
	$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
	
	$limitstart			= JRequest::getVar('limitstart',0,'','int');
	
	$query = 'SELECT COUNT(*)'.	          
			  ' FROM #__tpjobs_billing where employer_id = '.$user->id. " order by date_buy desc";	
     
	$db->setQuery( $query );
	$total = $db->loadResult();
	
	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );
	
	
	
	$query = 'SELECT * FROM #__tpjobs_billing where employer_id = '.$user->id . " order by date_buy desc";	
	
	$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
	$rows = $db->loadObjectList();
	
	HTML_front_tpjobs::showBilling($rows,$pageNav,$option);
}


//Show Credit
function showCredit($option)
{
	global $mainframe;
	$user	=& JFactory::getUser();
	$db		=& JFactory::getDBO();
	
	$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart	= $mainframe->getUserStateFromRequest($option.'.limitstart', 'limitstart', 0, 'int');

	
	if($user->id == 0){
		$return	= JRoute::_('index.php?option=com_user&view=login');
		$mainframe->redirect( $return );	
	}
	$is_employer = isEmployer($user->id);
	if($is_employer == 0){
		$return	= JRoute::_('index.php?option=com_tpjobs&task=regemployer');
		$mainframe->redirect( $return );	
	}
	
	$query = "select max(id) from #__tpjobs_transaction where employer_id = ".$user->id;
	$db->setQuery( $query );
	$id_max = $db->loadResult();
	
	$last_credit =& JTable::getInstance('transaction', 'Table');
	$last_credit->load($id_max);
	
	$plus =0;
	$minus = 0;
	$total_credit =0;
	$query = "select sum(credit_plus) from #__tpjobs_transaction where employer_id = ".$user->id;
	$db->setQuery( $query );
	$plus = $db->loadResult();
	
	
	$query = "select sum(credit_minus) from #__tpjobs_transaction where employer_id = ".$user->id;
	$db->setQuery( $query );
	$minus = $db->loadResult();
	
	$total_credit = $plus - $minus;
	
	
	
	$query = "SELECT COUNT(*)".	          
			 " FROM #__tpjobs_transaction ".
			 " WHERE employer_id =".$user->id;	
	$db->setQuery( $query );
	$total = $db->loadResult();
	
	
	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );

	
	$query = "SELECT *  ".
			 " FROM #__tpjobs_transaction ".
			 " WHERE employer_id =".$user->id;
	
	$db->setQuery($query,$pageNav->limitstart, $pageNav->limit );
	$rows = $db->loadObjectList();

	
	HTML_front_tpjobs::showCredit(&$rows,&$pageNav,$last_credit,$total_credit,$option);
}

//Buy Credit
function buyCredit($option)
{
	global $mainframe;
	$user	=& JFactory::getUser();
	$db		=& JFactory::getDBO();
	$row	=& JTable::getInstance('employer', 'Table');
	
	if($user->id == 0){
		$return	= JRoute::_('index.php?option=com_user&view=login');
		$mainframe->redirect( $return );	
	}

	if(!isEmployer($user->id)){
		$return	= JRoute::_('index.php?option=com_tpjobs&task=regemployer');
		$mainframe->redirect( $return );	
	}
	
	$query = "select id from #__tpjobs_employer where user_id =".$user->id;	
	$db->setQuery( $query );
	$id_employer = $db->loadResult();
	$row->load($id_employer);
	HTML_front_tpjobs::buyCredit($row,$option);
}

//Save Buy Credit
function saveBuyCredit($option)
{
	global $mainframe;
	$user	=& JFactory::getUser();
	$config = & JComponentHelper::getParams('com_tpjobs');	
	$price_credit  = $config->get('price_credit');
	
	// Check for request forgeries
	JRequest::checkToken() or jexit('Invalid Token');
	
	// Initialize variables
	$db		=& JFactory::getDBO();
	$row	=& JTable::getInstance('billing', 'Table');
	$post   = JRequest::get('post');
	$mode_pay = $post['mode_pay'];
	
	if (!$row->bind( $post )) {
		JError::raiseError(500, $row->getError() );
	}
	

	// pre-save checks
	if (!$row->check()) {
		JError::raiseError(500, $row->getError() );
	}

	
	$row->employer_id 	= $user->id;
	$row->date_buy    	= date('Y-m-d H:i:s', time() + ( $mainframe->getCfg('offset') * 60 * 60 ) );
	$row->amount 		= (int)$post['credit'] * $price_credit;
	
	// save the changes
	if (!$row->store()) {
		JError::raiseError(500, $row->getError() );
	}
	
	$row->checkin();
	
	
	if($row->mode_pay == 'm'){
		$link	= 'index.php?option=com_tpjobs&task=manualpayment&id='.$row->id ;
	}else{
		$link	= 'index.php?option=com_tpjobs&task=paypalpayment&id='.$row->id;
	}	
	

	$mainframe->redirect( $link, $msg );
	
}


//Manual Payment
function manualPayment($option){
	
	global $mainframe;
	$db		=& JFactory::getDBO();
	$row	=& JTable::getInstance('billing', 'Table');
	$id 	= JRequest::getVar('id', 0, 'get', 'int');
	
	$config = & JComponentHelper::getParams('com_tpjobs');	
	$db		=& JFactory::getDBO();
	$row	=& JTable::getInstance('billing', 'Table');
	
	$row->load($id);	
	
	HTML_front_tpjobs::manualPayment($option,$row->amount);
}


//Paypal Payment
function paypalPayment($option){
	$payment_key = array();
	$payment_key = array(
							 "txn_id" => "Transaction ID",
							 "payment_type" => "Payment Type",
							 "payment_date" => "Payment Date",
							 "payment_status" => "Payment Status",
							 "payment_gross" => "Payment Gross",
							 "first_name" => "First Name",
							 "last_name" => "Last Name",
							 "payer_email" => "Payer Email",
							 "payer_id" => "Payer ID",
							 "mc_currency" => "MC Currency",
							 "mc_gross" => "MC Gross",
							 "mc_fee" => "MC Fee",
							 "tax" => "Tax",
							 "payment_fee" => "Payment Fee",
							 "item_name" => "Item Name",
							 );


	global $mainframe;
	$db =& JFactory::getDBO();
	$row =& JTable::getInstance('billing', 'Table');
	$id = JRequest::getVar('id', 0, 'get', 'int');
	$user =& JFactory::getUser();
	$config = & JComponentHelper::getParams('com_tpjobs');	
	$ppemailaddr = $config->get('paypal_email');			
	$ptestmode = $config->get('ptestmode');	
	$currency = $config->get('currency');
	$currencytype = $config->get('currencytype');
	
	$row->load($id);
	
	
	
	$datetime = time();
	$total = $row->amount;		

	$orderid = $row->id;
	$itemname = "Buy Credit (".$row->credit." credit) by Paypal";
	
	$link_return = JRoute::_(JURI::base().'index.php?option=com_tpjobs&task=returnpaypal&oid='.$orderid);
	
	require_once (dirname(__FILE__) . '/paypal.class.php');  // include the class file

	$paypal = new paypal_class; // initiate an instance of the class

	$paypal->paypal_url = ($ptestmode) ? 'https://www.sandbox.paypal.com/cgi-bin/webscr' : 'https://www.paypal.com/cgi-bin/webscr';

	$paypal->add_field('business', $ppemailaddr);
	$paypal->add_field('return', $link_return);
	$paypal->add_field('cancel_return', JURI::base() . "index.php?option=com_tpjobs&task=cancelpaypal&oid=".$orderid);
	$paypal->add_field('notify_url', JURI::base() . "index.php?option=com_tpjobs&task=retpaypal&oid=".$orderid);
	$paypal->add_field('item_name', $itemname);
	$paypal->add_field('item_number', $orderid);
	$paypal->add_field('amount', $total);
	$paypal->add_field('invoice', $orderid);
	$paypal->add_field('no_note', "1");
	$paypal->add_field('no_shipping', "1");
	$paypal->add_field('currency_code', "USD");
	$paypal->submit_paypal_post(); // submit the fields to paypal

	?>
	<script>
	document.paypal_form.submit();
	</script>
	</form>
<?php
}

function returnPaypal($option)
{
	global $mainframe;
	$oid = JRequest::getVar('oid', 0, 'get', 'string');
	$db =& JFactory::getDBO();
	$user			=& JFactory::getUser();
	$did = $oid;

	if($did =='')
	{
		$msg = 'Your PayPal transaction could NOT be processed, no authentication code was provided for authorization.';		
		$link = JRoute::_('index.php?option=com_tpjobs');	

		//delete billing
		$query = "DELETE FROM #__tpjobs_billing WHERE id =".$oid;
		$db->setQuery( $query );
		if (!$db->query()) {
			echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";		
		}
	
		$mainframe->redirect( JRoute::_($link),$msg);	
	}
	else
	{
		$row = & JTable::getInstance('billing','Table');
		$row->load($did);
		
		require_once (JPATH_SITE.DS.'components'.DS.'com_tpjobs'.DS.'paypal.class.php');
		$paypal = new paypal_class; // initiate an instance of the class

		$config = & JComponentHelper::getParams('com_tpjobs');	
		$ptestmode = $config->get('ptestmode');
		$paypal->paypal_url = ($ptestmode) ? 'https://www.sandbox.paypal.com/cgi-bin/webscr' : 'https://www.paypal.com/cgi-bin/webscr';

		$now = date("Y-m-d H:i:s");
		if ($paypal->validate_ipn())
		{

			//action to transction
			$row_trans	=& JTable::getInstance('transaction', 'Table');
			$row_trans->date_trans = $date_approve;
			$row_trans->transaction ="Buy Credit (".$row->credit." credit)";
			$row_trans->employer_id = $row->employer_id;
			$row_trans->credit_plus = $row->credit;
			// pre-save checks
			if (!$row_trans->check()) {
							JError::raiseError(500, $row_trans->getError() );
			}	
			// save the changes
			if (!$row_trans->store()) {
				JError::raiseError(500, $row_trans->getError() );
			}
											
			$row_trans->checkin();				
			
			//save status billing "approved"		
			$row->id  = $did;
			$row->approval ='y';
			$date_approve   = date('Y-m-d H:i:s', time() + ( $mainframe->getCfg('offset') * 60 * 60 ) );
			$row->approval_date = $date_approve;
			$row->id_trans = $row_trans->id;
			
			// pre-save checks
			if (!$row->check())
			{
				JError::raiseError(500, $row->getError() );
			}
				
			// save the changes		
			if (!$row->store())
			{
				JError::raiseError(500, $row->getError() );		
			}
			$row->checkin();	
			
			$message = 'Your Paypal transaction for buying credit is success';	
			
		}
		else
		{
			$message = 'Your Paypal transaction is not valid!';
			
			//delete billing
			$query = "DELETE FROM #__tpjobs_billing WHERE id =".$oid;
			$db->setQuery( $query );
			if (!$db->query()) {
			echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";		
			}
		}
		

		$link = JRoute::_('index.php?option=com_tpjobs&task=billing');	
		$mainframe->redirect( JRoute::_($link),$message);	
	}

}


//Edit Job
function editJob($edit)
{
	global $mainframe;
	$db		=& JFactory::getDBO();
	$user 	=& JFactory::getUser();
	
	if(!$user->id OR !isEmployer($user->id))
	{
		$link = JRoute::_('index.php?option=com_tpjobs');
		$mainframe->redirect( JRoute::_($link),$message);	
	}
	
	$id = JRequest::getVar('id', 0, 'get', 'int');
	$option = JRequest::getCmd('option');

	JArrayHelper::toInteger($cid, array(0));

	$row =& JTable::getInstance('job','Table');
	if($edit){
		$row->load($id);
		if(empty($row->job_title))
		{
			$link = JRoute::_('index.php?option=com_tpjobs');
			$mainframe->redirect( JRoute::_($link),$message);	
		}
		if($row->employer_id != $user->id)
		{
			$link = JRoute::_('index.php?option=com_tpjobs');
			$mainframe->redirect( JRoute::_($link),$message);	
		}
	}
	
	$query = "select id from #__tpjobs_employer where user_id =".$user->id;
	$db->setQuery( $query );
	$employer_id = $db->loadResult();
	
	$employer = & JTable::getInstance('employer', 'Table');
	$employer->load($employer_id);
	
	HTML_front_tpjobs::editJob($row,$employer,$option);
}


//Save Job
function saveJob($option)
{
	global $mainframe;
	$user 	=& JFactory::getUser();
	
	// Check for request forgeries
	JRequest::checkToken() or jexit('Invalid Token');
	
	// Initialize variables
	$db		=& JFactory::getDBO();
	$row	=& JTable::getInstance('job', 'Table');
	$post   = JRequest::get('post');
	$post['short_desc'] = JRequest::getVar('short_desc', '', 'post', 'string', JREQUEST_ALLOWRAW);
	$post['long_desc'] = JRequest::getVar('long_desc', '', 'post', 'string', JREQUEST_ALLOWRAW);
	$post['employer_id'] = $user->id;
	
	if (!$row->bind( $post )) {
		JError::raiseError(500, $row->getError() );
	}
	

	// pre-save checks
	if (!$row->check()) {
		JError::raiseError(500, $row->getError() );
	}
	
	// save the changes
	if (!$row->store()) {
		JError::raiseError(500, $row->getError() );
	}
		
	$row->checkin();	
	$msg	= JText::_('JOB IS SAVED');
	$link	= 'index.php?option=com_tpjobs&task=yourjoblist';
	$mainframe->redirect( $link, $msg );
	
}

//Show Job
function showJob( $option )
{
	global $mainframe;
	$db	= & JFactory::getDBO();
	$user 	=& JFactory::getUser();
	
	if(!$user->id){
		$return	= JRoute::_('index.php?option=com_user&view=login');
		$mainframe->redirect( $return );	
	}
	
	if(!isEmployer($user->id))
	{
		$return	= JRoute::_('index.php?option=com_tpjobs');
		$mainframe->redirect( $return );	
	}
	
	$post   = JRequest::get('post');
	
	$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart	= $mainframe->getUserStateFromRequest($option.'.limitstart', 'limitstart', 0, 'int');
	
	$query = "SELECT COUNT(*)".	          
			 " FROM #__tpjobs_job a WHERE a.employer_id=$user->id";
	
	$db->setQuery( $query );
	$total = $db->loadResult();
	
	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );

	$query = "SELECT a.*,b.specialization  ".
			 " FROM #__tpjobs_job a".
			 " LEFT JOIN  #__tpjobs_job_spec b".
			 " ON a .id_job_spec = b.id WHERE a.employer_id=$user->id"
			 ;
	
	$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
	$rows = $db->loadObjectList();
	
	HTML_front_tpjobs::showJob($rows,$pageNav,$option);
}

//Job List
function jobList( $option )
{
	global $mainframe;
	$db	= & JFactory::getDBO();
	
	$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart	= $mainframe->getUserStateFromRequest($option.'.limitstart', 'limitstart', 0, 'int');
	
	$now = date('Y-m-d H:i:s', time() + ( $mainframe->getCfg('offset') * 60 * 60 ) );
	$where = " WHERE a.is_active='y' and a.expire_date > '".$now."' and a.expire_date <> '0000-00-00 00:00:00'";

	$query = "SELECT COUNT(*)".	          
			 " FROM #__tpjobs_job".
			 $where;
	
	$db->setQuery( $query );
	$total = $db->loadResult();
	
	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );

	$query = "SELECT a.*,b.specialization,c.country,d.comp_name as company  ".
			 " FROM #__tpjobs_job a".
			 " LEFT JOIN  #__tpjobs_job_spec b".
			 " ON a.id_job_spec = b.id".
			 " LEFT JOIN  #__tpjobs_country c".
			 " ON a.id_country = c.id".
			 " LEFT JOIN  #__tpjobs_employer d".
			 " ON a.employer_id = d.user_id".
			 $where
			 ;
	
	$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
	$rows = $db->loadObjectList();
	
	HTML_front_tpjobs::jobList($rows,$pageNav,$option);
}

//publishJob
function publishJob($option){
	global $mainframe;
	
	$db		=& JFactory::getDBO();
	$user 	=& JFactory::getUser();

	$option = JRequest::getCmd('option');
	$post   = JRequest::get('post');	
	$id 	= JRequest::getVar('id', 0, 'get', 'int');
	
	if(empty($id))
	{
		$return	= JRoute::_('index.php?option=com_tpjobs');
		$mainframe->redirect( $return );	
	}
	
	if($user->id == 0){
		$return	= JRoute::_('index.php?option=com_user&view=login');
		$mainframe->redirect( $return );	
	}

	$is_employer = isEmployer($user->id);
	if($is_employer == 0){
		$return	= JRoute::_('index.php?option=com_tpjobs&task=regemployer');
		$mainframe->redirect( $return );	
	}
	
	$row =& JTable::getInstance('job','Table');
	$row->load($id);
	
	if($row->employer_id != $user->id)
	{
		$return	= JRoute::_('index.php?option=com_tpjobs');
		$mainframe->redirect( $return );	
	}

	$query = "select distinct expires as value from #__tpjobs_packet_use".
	         " where employer_id = ".$user->id . " and id_job = 0" ;		 
	
	$db->setQuery( $query );
	$pack_exp = $db->loadObjectList();
		
		$types[] 		= JHTML::_('select.option',  '0', '- '. JText::_('EXPIRES') .' -');
		foreach( $pack_exp as $item )
		{
			$types[] = JHTML::_('select.option',  $item->value, JText::_( $item->value ) );
		}		
		
		$lists 	= JHTML::_('select.genericlist',   $types, 'expires', 'class="inputbox" size="1"', 'value', 'text','0');
	
	HTML_front_tpjobs::publishJob($row,$lists,$option);

}


//Save Publish Job
function savePublishJob($option)
{
	global $mainframe;
	
	// Check for request forgeries
	JRequest::checkToken() or jexit('Invalid Token');
	
	// Initialize variables
	$db		=& JFactory::getDBO();
	$job	=& JTable::getInstance('job', 'Table');
	$post   = JRequest::get('post');
	$id_job = (int)$post['id'];
	$expires = (int)$post['expires'];
	$job->load($id_job);
	
	//check first, job already publish or not
	$now  = date('Y-m-d H:i:s', time() + ( $mainframe->getCfg('offset') * 60 * 60 ) );	
	if($job->publish_date != '0000-00-00 00:00:00' || ($job->expiress > $now)){
		echo "<script> alert('This job has been published.'); 	window.history.go(-1); </script>\n";
		exit();
	}
	
	//cek id 
	$query = "select min(id) as id from #__tpjobs_packet_use".
	         " where employer_id = ".$job->employer_id.
			 " and $expires =".$expires. " and id_job = 0";
	
	$db->setQuery( $query );
	$min_id = $db->loadResult();	
	$min_id;
	
	$row	= & JTable::getInstance('packetUse', 'Table');
	$row->load($min_id);
	$row->id_job = $job->id;

	// pre-save checks
	if (!$row->check()) {
		JError::raiseError(500, $row->getError() );
	}
	
	// save the changes
	
	if (!$row->store()) {
		JError::raiseError(500, $row->getError() );
	}
	
	$row->checkin();
	
	$date_expires = date("Y-m-d H:i:s", strtotime($date_publish . "+".$expires." day"));	

	$job->publish_date = $now;
	$job->expire_date  = $date_expires;
	
	// pre-save checks
	if (!$job->check()) {
		JError::raiseError(500, $job->getError() );
	}
	
	// save the changes	
	if (!$job->store()) {
		JError::raiseError(500, $job->getError() );
	}
	
	$msg	= JText::_('JOB HAS BEEN PUBLISHED');
	$link	= 'index.php?option=com_tpjobs&task=yourjoblist';
	$mainframe->redirect( $link, $msg );
	
}

//find Resume
function findResume($option){

	global $mainframe;
	
	$db		=& JFactory::getDBO();
	$user 	=& JFactory::getUser();

	if(!$user->id){
		$return	= JRoute::_('index.php?option=com_user&view=login');
		$mainframe->redirect( $return );	
	}
	
	if(!isEmployer($user->id))
	{
		$return	= JRoute::_('index.php?option=com_tpjobs');
		$mainframe->redirect( $return );	
	}

	$post   = JRequest::get('post');
	$keyword = (!empty($post['keyword'])) ? $post['keyword'] : null;
	$id_job_spec      = (!empty($post['id_job_spec'])) ? (int)$post['id_job_spec'] : 0;
	$id_major 	      = (!empty($post['id_major'])) ? (int)$post['id_major'] : 0;
	$id_job_exp  	  	= (!empty($post['id_job_exp'])) ? (int)$post['id_job_exp'] : 0;
	$id_degree_level  = (!empty($post['id_degree_level'])) ? (int)$post['id_degree_level'] : 0;
	$is_applicant  	  = (!empty($post['is_applicant'])) ? (int)$post['is_applicant'] : 0;
	$id_search_job    = (!empty($post['id_search_job'])) ? (int)$post['id_search_job'] : 0;
	
	$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart	= $mainframe->getUserStateFromRequest($option.'.limitstart', 'limitstart', 0, 'int');
	
	$where = " where a.job_title like '%".$keyword."%'";
	
	if($id_job_spec > 0){
		$where .= " and a.id_job_spec =".$id_job_spec ;
	}
	
	if($id_job_exp > 0){
		$where .= " and a.id_job_exp =".$id_job_exp ;
	}
	
	if($id_degree_level > 0){
		$where .= " and a.id_degree_level =".$id_degree_level ;
	}
	
	$total = 0;
	
	if(!empty($_POST))
	{
		$query = "SELECT COUNT(*)".	          
				 " FROM #__tpjobs_job a".
				 " LEFT JOIN  #__tpjobs_country b".
				 " ON a.id_country = b.id".
				    $where.
				 " and a.employer_id = ".$user->id;		
	
		$db->setQuery( $query );
		$total = $db->loadResult();
	}
	
	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );
	
	$rows = null;
	if(!empty($_POST))
	{
		$query = " SELECT a.*,b.country ".
				 " FROM #__tpjobs_job a".
				 " LEFT JOIN #__tpjobs_country b".
				 " ON a.id_country = b.id".			 
				   $where.
				 " and a.employer_id = ".$user->id;		
		
		$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
		$rows = $db->loadObjectList();
	}

	$applicants = null;
	if(!empty($_POST))
	{
		if($is_applicant == 1){
			$query ="select a.*,b.*, c.name from #__tpjobs_save_job a".
					" left join #__tpjobs_jobseeker b".
					" ON a.jseeker_id = b.user_id".
					" LEFT JOIN  #__users c".
					" ON a.jseeker_id = c.id".
					" where id_job =".$id_search_job.
					" and is_apply ='y'";
			if($id_major >0){
				$query .="and a.id_major = ".$id_major;
			}
			//echo $query."<BR>";
			$db->setQuery($query);
			$applicants = $db->loadObjectList();
		}
	}
	HTML_front_tpjobs::findResume($rows,$option,$pageNav,$applicants);

}

//Buy Packet
function buyPacket($option)
{
	global $mainframe;
	$user	=& JFactory::getUser();
	$db		=& JFactory::getDBO();
	$row	=& JTable::getInstance('employer', 'Table');
	
	if($user->id == 0){
		$return	= JRoute::_('index.php?option=com_user&view=login');
		$mainframe->redirect( $return );	
	}
	$is_employer = isEmployer($user->id);
	if($is_employer == 0){
		$return	= JRoute::_('index.php?option=com_tpjobs&task=regemployer');
		$mainframe->redirect( $return );	
	}
	
	 //make selection user
		$query = 'select a.id as value, username as text from #__users a'.
				  ' inner join #__tpjobs_employer b ON a.id = b.user_id' ;
		$db->setQuery( $query );
		
		
		$users = $db->loadObjectList();
		
		$types[] 		= JHTML::_('select.option',  '0', '- '. JText::_('SELECT USER ID (EMPLOYER)') .' -');
		foreach( $users as $item )
		{
			$types[] = JHTML::_('select.option',  $item->value, JText::_( $item->text ) );
		}
		
	$lists 	= JHTML::_('select.genericlist',   $types, 'employer_id', 'class="inputbox" size="1"', 'value', 'text', $row->user_id ? $row->user_id :'0');
	HTML_front_tpjobs::buyPacket($option,$lists);
	
}

//saveBuyPacket
function saveBuyPacket($option){
	global $mainframe;
	$user	=& JFactory::getUser();
	// Check for request forgeries
	JRequest::checkToken() or jexit('Invalid Token');

	// Initialize variables
	$db =& JFactory::getDBO();	
	
	$post   		= JRequest::get('post');
	$config 		= & JComponentHelper::getParams('com_tpjobs');	
	$minimum_credit = $config->get('minimum_credit');
	

	$employer_id = $user->id;

	$credit_employer = getCreditEmployer($employer_id);
	
	
	
	$packet = & JTable::getInstance('packet', 'Table');
	$packet->load((int)$post['id_packet']);
	
	$date_buy  = date('Y-m-d H:i:s', time() + ( $mainframe->getCfg('offset') * 60 * 60 ) );
	
	if(($credit_employer - $packet->credit) < $minimum_credit){
		echo "<script> alert('You dont have enough credit to take this packet. Please buy credit'); window.history.go(-1); </script>\n";
		exit();
	
	}
	
	//INSERT TRANSACTION
	//action to transaction
	$row_trans	=& JTable::getInstance('transaction', 'Table');
	$row_trans->date_trans = $date_buy;
	$row_trans->transaction ="Buy Packet : ".$packet->packet." (".$packet->credit." credit)";
						
	$row_trans->credit_minus = $packet->credit;
	$row_trans->employer_id =  $employer_id;
	
	// pre-save checks
	if (!$row_trans->check()) {
		JError::raiseError(500, $row_trans->getError() );
	}	
	if (!$row_trans->store()){
			JError::raiseError(500, $row_trans->getError() );
	}											
	$row_trans->checkin();



	//INSERT TO PACKET_BUY
	$row = & JTable::getInstance('packetBuy', 'Table');
	if (!$row->bind( $post )) {
		JError::raiseError(500, $row->getError() );
	}	
	

	// pre-save checks
	if (!$row->check()) {
		JError::raiseError(500, $row->getError() );
	}
	
	$row->date_buy    = $date_buy;
	$row->id_trans 	  = $row_trans->id;
	$row->amount_day  = $packet->amount_day;
	$row->amount_job  = $packet->amount_job;
	$row->credit      = $packet->credit;
	$row->packet      = $packet->packet;
	
	// save the changes
	if (!$row->store()) {
		JError::raiseError(500, $row->getError() );
	}
	
	$row->checkin();
	
	//FOR VOUCHER
	$count_job = $packet->amount_job;
	for($i=1;$i<=$count_job;$i++){
		$row_packet_use  = & JTable::getInstance('packetUse', 'Table');
		$row_packet_use->id_trans 		= $row_trans->id;
		$row_packet_use->id_packet 		= $row->id_packet;
		$row_packet_use->expires 		= $row->amount_day;
		$row_packet_use->employer_id 	= $employer_id;
		
		
		// pre-save checks
		if (!$row_packet_use->check()) {
			JError::raiseError(500, $row_packet_use->getError() );
		}
		
		// save the changes
		if (!$row_packet_use->store()) {
			JError::raiseError(500, $row_packet_use->getError() );
		}
		
	}
	
	$msg	= JText::_('JOB PACKET IS SAVED FOR YOU');
	$link	= 'index.php?option=com_tpjobs&task=credit';
	$mainframe->redirect( $link, $msg );

}



//regEmployerNew
function regEmployerNew($option)
{
	global $mainframe;
	$user	=& JFactory::getUser();

	// if logged user try to register new then redirect to tpjobs index
	if($user->id)
	{
		$return	= JRoute::_('index.php?option=com_tpjobs');
		$mainframe->redirect( $return );
		return;
	}

	HTML_front_tpjobs::regEmployerNew($option);
}


//saveEmployerNew
function saveEmployerNew($option)
{
	global $mainframe;
	$user =& JFactory::getUser();
	

	// Check for request forgeries
	JRequest::checkToken() or jexit('Invalid Token');

	////////////////////////////////////////

	$post = JRequest::get('post');
	
	$post['name'] = (!empty($post['firstname'])) ? $post['firstname'] : null;
	$post['name'] .= (!empty($post['name']) && !empty($post['lastname'])) ? ' ' . $post['lastname'] : null;
	
	// Get required system objects
	$usern = clone(JFactory::getUser());
	$pathway =& $mainframe->getPathway();
	$config =& JFactory::getConfig();
	$authorize =& JFactory::getACL();
	$document =& JFactory::getDocument();
	
	$lang =& JFactory::getLanguage();
 	$lang->load('com_user', JPATH_SITE);

	// If user registration is not allowed, show 403 not authorized.
	$usersConfig = &JComponentHelper::getParams('com_users');
	if ($usersConfig->get('allowUserRegistration') == '0') {
		JError::raiseError( 403, JText::_('ACCESS FORBIDDEN'));
		return;
	}
	
	// Initialize new usertype setting
	$newUsertype = $usersConfig->get('new_usertype');
	if (!$newUsertype) {
		$newUsertype = 'Registered';
	}
	
	// Bind the post array to the user object
	if (!$usern->bind( $post, 'usertype')) {
		JError::raiseError( 500, $usern->getError());
	}
	
	// Set some initial user values
	$usern->set('id', 0);
	$usern->set('usertype', '');
	$usern->set('gid', $authorize->get_group_id('', $newUsertype, 'ARO'));
	$date =& JFactory::getDate();
	$usern->set('registerDate', $date->toMySQL());
	
	// If user activation is turned on, we need to set the activation information
	$useractivation = $usersConfig->get('useractivation');
	if ($useractivation == '1')
	{
		jimport('joomla.user.helper');
		$usern->set('activation', JUtility::getHash( JUserHelper::genRandomPassword()) );
		$usern->set('block', '1');
	}
	
	// If there was an error with registration, set the message and display form
	if ( !$usern->save() )
	{
		$msg = JText::_( $usern->getError());
		$link = JRoute::_('index.php?option=com_tpjobs&task=regemployernew');	
		$mainframe->redirect( JRoute::_($link), $msg );
		return false;
	}
	
	
	$userid = $usern->id;

	
	// Check for request forgeries
	JRequest::checkToken() or jexit('Invalid Token');
	
	// Initialize variables
	$db		=& JFactory::getDBO();
	$row	=& JTable::getInstance('employer', 'Table');
	$post   = JRequest::get('post');
	$id = (!empty($post['id'])) ? (int)$post['id'] : 0;
		
	$row->user_id = $userid;
	
	
	
	if (!$row->bind( $post )) {
		JError::raiseError(500, $row->getError() );
	}
	

	// pre-save checks
	if (!$row->check()) {
		JError::raiseError(500, $row->getError() );
	}

	
	// if new item,  last in appropriate group
	if (!$row->id) {
		$where = "id = " . (int) $row->id;		
	}
	
	
	// save the changes
	if (!$row->store()) {
		JError::raiseError(500, $row->getError() );
	}
	
	
	$row->checkin();
	
	//give bonus signup
	
	    $date_trans  = date('Y-m-d H:i:s', time() + ( $mainframe->getCfg('offset') * 60 * 60 ) );
		$config 		= & JComponentHelper::getParams('com_tpjobs');	
		$bonus_signup_emp = $config->get('bonus_signup_emp');
		
		$trans = & JTable::getInstance('transaction','Table');
		$trans->date_trans  = $date_trans;
		$trans->transaction = "Bonus for registration as employer";	
		$trans->credit_plus = $bonus_signup_emp;
		$trans->employer_id = $row->user_id;
		
		// pre-save checks
		if (!$trans->check()) {
			JError::raiseError(500, $trans->getError() );
		}
		// save the changes
		if (!$trans->store()) {
			JError::raiseError(500, $trans->getError() );
		}
		$trans->checkin();
		
	
	
	// Send registration confirmation mail
	$password = JRequest::getString('password', '', 'post', JREQUEST_ALLOWRAW);
	$password = preg_replace('/[\x00-\x1F\x7F]/', '', $password); //Disallow control chars in the email
	TPJobSendMail($usern, $password);
	
	if(!empty($_FILES['photo']))
	{
		tpjobsUploadPhoto($_FILES['photo'], $row->user_id);
	}
	
	$link	= JRoute::_('index.php?option=com_tpjobs');	
	//$mainframe->redirect( JRoute::_($link));
}


/**
==================================================================================================================	
	SECTION : JobSeeker
	1.editJobSeeker
	2.saveJobSeeker
	3.editResume
	4.viewResume
	5.saveResume
	6.removeResume
	7.saveJob
	8.regJobSeekerNew
	9.saveJobSeekerNew
	
==================================================================================================================
*/
//editJobSeeker
function editJobSeeker($edit)
{
	global $mainframe, $option;
	$user	=& JFactory::getUser();
	
	// if logged user try to register new then redirect to tpjobs index
	if(isEmployer($user->id))
	{
		$return	= JRoute::_('index.php?option=com_tpjobs');
		$mainframe->redirect( $return );	
		return;
	}

	$db		=& JFactory::getDBO();
	
	if($user->id == 0){
		$return	= JRoute::_('index.php?option=com_user&view=login');
		$mainframe->redirect( $return );	
	}
	
	$row =& JTable::getInstance('jobseeker','Table');
	
	if($edit){
		$query = "select id from #__tpjobs_jobseeker where user_id =".$user->id;	
		$db->setQuery( $query );
		$id_jobseeker = $db->loadResult();
		$row->load($id_jobseeker);
	}
	HTML_front_tpjobs::regJobSeeker($row,$option);
}

//saveJobSeeker
function saveJobSeeker($option)
{
	global $mainframe;
	$user	=& JFactory::getUser();
	
	// Check for request forgeries
	JRequest::checkToken() or jexit('Invalid Token');
	
	// Initialize variables
	$db		=& JFactory::getDBO();
	$row	=& JTable::getInstance('jobseeker', 'Table');
	$post   = JRequest::get('post');
	
	$row->user_id = $user->id;
	
	if (!$row->bind( $post )) {
		JError::raiseError(500, $row->getError() );
	}

	// pre-save checks
	if (!$row->check()) {
		JError::raiseError(500, $row->getError() );
	}
	
	// save the changes
	if (!$row->store()) {
		JError::raiseError(500, $row->getError() );
	}	
	
	$row->checkin();
	
	if(!empty($_FILES['photo']))
	{
		tpjobsUploadPhoto($_FILES['photo'], $row->user_id);
	}
	
	$link	= JRoute::_('index.php?option=com_tpjobs');	
	$mainframe->redirect( JRoute::_($link));


}


//editResume
function editResume($edit)
{
	global $mainframe, $option;
	$user	=& JFactory::getUser();
	$db		=& JFactory::getDBO();
	$id 	= JRequest::getVar('id', 0, 'get', 'int');
	
	if(!$user->id){
		$return	= JRoute::_('index.php?option=com_user&view=login');
		$mainframe->redirect( $return );	
	}
	
	if(!isJobSeeker($user->id))
	{
		$return	= JRoute::_('index.php?option=com_tpjobs');
		$mainframe->redirect( $return );	
	}

	$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart	= $mainframe->getUserStateFromRequest($option.'.limitstart', 'limitstart', 0, 'int');

	$row =& JTable::getInstance('resume','Table');
	
	if($edit){
		$row->load($id);
	}
	
	//get resume of jobseeker
	$post   = JRequest::get('post');
	
	
	
	$query = "SELECT COUNT(*)".	          
		 	 " FROM #__tpjobs_resume  where jseeker_id  =".$user->id ;
	
	
	$db->setQuery( $query );
	$total = $db->loadResult();
	
	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );

	
	$query = "SELECT * ".	          
			 " FROM #__tpjobs_resume  where jseeker_id  =".$user->id ;
			
	
	$db->setQuery( $query);
	$resumes = $db->loadObjectList();
	
	HTML_front_tpjobs::editResume($row,$option,$resumes);
}

//viewResume
function viewResume($option)
{
	global $mainframe;
	$user	=& JFactory::getUser();
	
	if(!$user->id)
	{
		$return	= JRoute::_('index.php?option=com_users&task=login');
		$mainframe->redirect( $return );	
	}
	
	$db		=& JFactory::getDBO();
	$id 	= JRequest::getVar('id', 0, 'get', 'int');
	
	$row =& JTable::getInstance('resume','Table');
	$row->load($id);
	
	if($row->jseeker_id != $user->id)
	{
		if(isJobSeeker($user->id))
		{
			$return	= JRoute::_('index.php?option=com_tpjobs');
			$mainframe->redirect( $return );	
			return;
		}
		
		$query = "SELECT count(*) FROM #__tpjobs_save_job s INNER JOIN #__tpjobs_job j ON s.id_job=j.id WHERE s.jseeker_id=$row->jseeker_id AND s.is_apply='y' AND j.employer_id=$user->id";
		$db->setQuery($query);
		if(!$db->loadResult())
		{
			$return	= JRoute::_('index.php?option=com_tpjobs');
			$mainframe->redirect( $return );	
			return;
		}

		if($row->is_active == 'n')
		{
			$return	= JRoute::_('index.php?option=com_tpjobs');
			$mainframe->redirect( $return );	
			return;
		}
	}
	
	HTML_front_tpjobs::viewResume($row,$option);
}

//saveResume
function saveResume($option)
{
	global $mainframe;
	$user	=& JFactory::getUser();
	
	// Check for request forgeries
	JRequest::checkToken() or jexit('Invalid Token');
	
	if(isJobSeeker($user->id) == 0){
		$return	= JRoute::_('index.php?option=com_tpjobs&task=regjobseeker');
		$mainframe->redirect( $return );	
	}	
	
	// Initialize variables
	$db		=& JFactory::getDBO();
	$row	=& JTable::getInstance('resume', 'Table');
	$post   = JRequest::get('post');
	$id 	 = (!empty($post['id'])) ? (int) $post['id'] : 0;	
	$type_resume 	 = (!empty($post['type'][0])) ?  $post['type'][0] : 'c';	
	$name_resume     = (!empty($post['name_resume'])) ?  $post['name_resume'] : '';	
	$description     = JRequest::getVar('description', '', 'post', 'string', JREQUEST_ALLOWRAW);
	$resume     	 = JRequest::getVar('resume', '', 'post', 'string', JREQUEST_ALLOWRAW);	
	$is_active 	 	 = (!empty($post['is_active'])) ?  $post['is_active'] : 'n';	
	
	
	
	if($is_active=='y'){
		$query = "UPDATE #__tpjobs_resume SET is_active ='n' where jseeker_id =".$user->id ;	
		$db->setQuery( $query );
		if (!$db->query()) {
			echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";		
		}
	}
	
	//count resume 
	$query = "SELECT COUNT(*)".	          
		 	 " FROM #__tpjobs_resume  where jseeker_id  =".$user->id ;
	
	
	$db->setQuery( $query );
	$total = $db->loadResult();
	
	
	if($total >=3 && $id==0){
			echo "<script> alert('Maximum resume = 3'); window.history.go(-1); </script>\n";
			exit ();
	}
	
	if($id > 0){
		$row->load($id);		
	}
	$row->id = $id;
	$row->name_resume = $name_resume;
	$row->description = $description;	
	$row->jseeker_id  = $user->id;
	$row->resume  	  = $resume;
	$row->type  	  = $type_resume;
	$row->is_active   = $is_active;
	
	//UPLOAD FILE
	jimport('joomla.filesystem.file');
	$file = $_FILES['file_resume'];		
	$config = & JComponentHelper::getParams('com_tpjobs');		
	$type ='bmp,csv,doc,gif,ico,jpg,jpeg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,GIF,ICO,JPG,JPEG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS';
	$allowed = explode(',',$type);
	if($file['size'] > 0){
		
		if($file['error'] != 0){
			echo "<script> alert('Upload file error.'); window.history.go(-1); </script>\n";
			exit ();
		}
		
		if($file['size'] == 0){
			$file = null;
		}
		
		$format = strtolower(JFile::getExt($file['name']));
		
 		if(!in_array($format, $allowed)) {
			echo "<script> alert('Your file is ignored.'); window.history.go(-1); </script>\n";
			exit ();
			$file = null;
 		}
		
		$old_doc = $row->file_resume;		
		
		if ($file != null){
		
	    if(!file_exists(JPATH_SITE . DS. 'images' . DS . 'tpjobs' . DS . 'pf'))
	    {
	    	
			if(mkdir(JPATH_SITE . DS . 'images' . DS . 'tpjobs' . DS . 'pf')) {
			    JPath::setPermissions(JPATH_SITE . DS . 'images' . DS . 'tpjobs' . DS . 'pf', '0777');
			    if(file_exists(JPATH_SITE . DS . 'images' . DS . 'index.html')) {
			    	copy(JPATH_SITE . DS . 'images' . DS . 'index.html', JPATH_SITE . DS . 'images' . DS . 'tpjobs/pf/index.html');
			    }
			  }
	    }

			$doc = explode(".",$file['name']);					
			$new_doc = "p_".$user->id."_".strtotime("now").".".$doc[count($doc)-1];
			$dest = JPATH_SITE.DS.'images'.DS.'tpjobs'.DS.'pf'.DS.$new_doc;
			$soure = $file['tmp_name'];
			
			// Move uploaded file
			
			$uploaded = JFile::upload($soure,$dest);
				
				
			if($old_doc !="" || !empty($old_doc)){
					$old_doc_file = explode("/",$old_doc);				
					$delete =JPATH_SITE.DS.'images'.DS.'tpjobs'.DS.'pf'.DS.$old_doc_file[count($old_doc_file)-1];
					echo $delete;
					unlink($delete);
			}
				
			$row->file_resume = JURI::base().'images/tpjobs/pf/'.$new_doc;
				
		
		} 	
	}

	
	
	if($file['size'] > 0 && $type_resume =='f'){
		$row->type ='f';
		$row->resume ='';
	}else{
		$row->type ='c';
		$old_doc = $row->file_resume;
		if($old_doc !="" || !empty($old_doc)){
					$old_doc_file = explode("/",$old_doc);				
					$delete =JPATH_SITE.DS.'images'.DS.'tpjobs'.DS.'pf'.DS.$old_doc_file[count($old_doc_file)-1];
					
					unlink($delete);
		}
		$row->file_resume = '';
		$row->resume = $resume;
	}
	
	
	
	// pre-save checks
	if (!$row->check()) {
		JError::raiseError(500, $row->getError() );
	}
	
	// save the changes
	if (!$row->store()) {
		JError::raiseError(500, $row->getError() );
	}	
	
	$row->checkin();

	$link	= JRoute::_('index.php?option=com_tpjobs&task=postresume');	
	$mainframe->redirect( JRoute::_($link));
	
}


//removeResume
function removeResume($option)
{
	global $mainframe;
	$user	=& JFactory::getUser();	
	
	$post   = JRequest::get('post');
	$id 	= JRequest::getVar('id', 0, 'get', 'int');
	$db		=& JFactory::getDBO();
	$query = "DELETE FROM #__tpjobs_resume where id =".$id ;
	echo $query;
	$db->setQuery( $query );
	if (!$db->query()) {
		echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";		
	}
	
	$link	= JRoute::_('index.php?option=com_tpjobs&task=editresume');	
	$mainframe->redirect( JRoute::_($link));

}


//saveJob
function applyJobByJS($apply)
{
	global $mainframe;
	$user	=& JFactory::getUser();
	$db		=& JFactory::getDBO();
	$post   = JRequest::get('post');
	$id_job = $post['id_job'];
	$return = $post['return'];
	
	if($user->id == 0){
		$return	= JRoute::_('index.php?option=com_user&view=login');
		$mainframe->redirect( $return );	
	}
	
	if(isJobSeeker($user->id) == 0){
		$return	= JRoute::_('index.php?option=com_tpjobs&task=regjobseeker');
		$mainframe->redirect( $return );	
	}	
	
	$row =& JTable::getInstance('saveJob','Table');
	
	$query = "select count(*) from #__tpjobs_save_job".
		         " where id_job = ".$id_job.
				 " and jseeker_id =".$user->id;
	$db->setQuery( $query );
	$cek_save = $db->loadResult();		
	
	
	$query = "select count(*) from #__tpjobs_save_job".
		         " where is_apply ='y' and id_job = ".$id_job.				 
				 " and jseeker_id =".$user->id;
	$db->setQuery( $query );
	$cek_apply = $db->loadResult();	
	
	if($cek_save ==1){
			//find id
			$query = "select id from #__tpjobs_save_job".
		         	 " where id_job = ".$id_job.				 
				 	 " and jseeker_id =".$user->id;
			$db->setQuery( $query );
			$cek_id = $db->loadResult();	
			$row->id = $cek_id;			
	}
	
	if($apply){
		if($cek_apply ==1){
			echo "<script> alert('".JText::_('THIS JOB HAS BEEN APPLIED')."'); window.history.go(-1); </script>\n";		
			exit;
		}
		$row->is_apply = 'y';
		
	}else{
		$query = "select count(*) from #__tpjobs_save_job".
		         " where is_view='y' and id_job= ".$id_job.
				 " and jseeker_id =".$user->id;
		
		$db->setQuery( $query );
		$cek_save_view = $db->loadResult();
		
		if($cek_save_view ==1){
			echo "<script> alert('".JText::_('THIS JOB HAS BEEN SAVE')."'); window.history.go(-1); </script>\n";		
			exit;
		}
	}
	
	$row->id_job = $id_job;
	$row->jseeker_id = $user->id;
	$row->is_view = 'y';
	// pre-save checks
	if (!$row->check()) {
		JError::raiseError(500, $row->getError() );
	}	
	// save the changes
	if (!$row->store()) {
		JError::raiseError(500, $row->getError() );
	}
	$row->checkin();
	
	if($row->is_apply == 'y')
	{
		$siteURL = JURI::base();
	
		$mailer = & JFactory::getMailer();
		$mode = 1;
	
		$query = "SELECT * FROM #__tpjobs_job WHERE id=$id_job";
		$db->setQuery($query);
		$job = $db->loadObject();

		// Build e-mail message format
		$message = 'JobSeeker ('.$user->username.') has applied to your job posting<br>';
		$message .= 'Your job title: <a href="'.$siteURL.'index.php?option=com_tpjobs&task=detailjob&id='.$id_job.'">' . $job->job_title . '</a><br><br>';
		$mailer->setSender(array($mainframe->getCfg('mailfrom'), $mainframe->getCfg('fromname')));
		$subject = 'JobSekker has applied to your job listing';
		$mailer->setSubject('JobSekker [' . $user->username . '] has applied to your job listing');
		$mailer->setBody($message);
		$mailer->IsHTML($mode);
	
	 	$query = "SELECT u.email FROM #__users u INNER JOIN #__tpjobs_job j ON u.id=j.employer_id WHERE j.id=$id_job";
	 	$db->setQuery($query);
	 	$mail = $db->loadResult();
	 	if($mail)
	 	{
		 	$mailer->addRecipient($mail);
			$mailer->Send();
		}
	}
	
	$link	= JRoute::_('index.php?option=com_tpjobs&task=mysavedjob');	
	$mainframe->redirect( $link);

	
}


//deleteSaveJob
function deleteSaveJob($option){
	global $mainframe;
	$user	=& JFactory::getUser();
	$db =& JFactory::getDBO();
	$post = JRequest::get('post');
	$id_job = (!empty($post['id_job'])) ? $post['id_job'] : null;
	
	if($id_job)
	{
		$query = "UPDATE #__tpjobs_save_job SET is_view ='n' ".
	         " WHERE id_job =".$id_job." and jseeker_id =".$user->id ;
	
		$db->setQuery( $query );
		if (!$db->query()) {
			echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";		
		}
	}
	
	$link	= JRoute::_('index.php?option=com_tpjobs&task=mysavedjob');	
	$mainframe->redirect( $link);

}


//deleteSaveJob
function deleteAllSaveJob($option){
	global $mainframe;
	$user	=& JFactory::getUser();
	$db		=& JFactory::getDBO();
	$post   = JRequest::get('post');
	$id_job = $post['id_job'];
	
	$query = "UPDATE #__tpjobs_save_job SET is_view ='n' ".
	         " WHERE jseeker_id =".$user->id ;
	
	$db->setQuery( $query );
	if (!$db->query()) {
		echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";		
	}
	
	$link	= JRoute::_('index.php?option=com_tpjobs&task=mysavedjob');	
	$mainframe->redirect( $link);

}

//mySavedJob
function mySavedJob($option){
	global $mainframe;
	$user	=& JFactory::getUser();

	if($user->id == 0){
		$return	= JRoute::_('index.php?option=com_user&view=login');
		$mainframe->redirect( $return );	
	}
	
	if(!isJobSeeker($user->id)){
		$return	= JRoute::_('index.php?option=com_tpjobs');
		$mainframe->redirect( $return );	
	}	

	$db		=& JFactory::getDBO();	
	
	$post   = JRequest::get('post');
	
	$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart	= $mainframe->getUserStateFromRequest($option.'.limitstart', 'limitstart', 0, 'int');
	
	$query = "SELECT COUNT(*)".	          
			 " FROM #__tpjobs_save_job a".
			 " LEFT JOIN  #__tpjobs_job b".
			 " ON a .id_job = b.id".
			 " LEFT JOIN #__tpjobs_employer d ".
			 " ON b.employer_id = d.user_id ".
			 " LEFT JOIN #__tpjobs_country c".
			 " ON b.id_country = c.id".
			 " WHERE a.jseeker_id =".$user->id ." and is_view ='y'";	

	$db->setQuery( $query );
	$total = $db->loadResult();
	
	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );
	
	$query = "SELECT a.*,b.job_title,d.comp_name,b.state,c.country,b.is_active ".
			 " FROM #__tpjobs_save_job a".
			 " LEFT JOIN  #__tpjobs_job b".
			 " ON a .id_job = b.id".
			 " LEFT JOIN #__tpjobs_employer d ".
			 " ON b.employer_id = d.user_id ".
			 " LEFT JOIN #__tpjobs_country c".
			 " ON b.id_country = c.id".
			 " WHERE a.jseeker_id =".$user->id ." and is_view ='y'";		
	
	$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
	$rows = $db->loadObjectList();
	
	HTML_front_tpjobs::mySavedJob($rows,$pageNav,$option);
}

//regJobSeekerNew
function regJobSeekerNew($edit)
{
	global $option, $mainframe;
	$user	=& JFactory::getUser();

	// if logged user try to register new then redirect to tpjobs index
	if($user->id)
	{
		$return	= JRoute::_('index.php?option=com_tpjobs');
		$mainframe->redirect( $return );
		return;
	}

	HTML_front_tpjobs::regJobSeekerNew($option);
}

//saveJobSeekerNew
function saveJobSeekerNew($option)
{
	global $mainframe;
	$user	=& JFactory::getUser();
	
	// Check for request forgeries
	JRequest::checkToken() or jexit('Invalid Token');
	
	// Initialize variables
	$db		=& JFactory::getDBO();
	$row	=& JTable::getInstance('jobseeker', 'Table');
	$post   = JRequest::get('post');
	
	

	////////////////////////////////////////

	// Get required system objects
	$usern = clone(JFactory::getUser());
	$pathway =& $mainframe->getPathway();
	$config =& JFactory::getConfig();
	$authorize =& JFactory::getACL();
	$document =& JFactory::getDocument();
	
	// If user registration is not allowed, show 403 not authorized.
	$usersConfig = &JComponentHelper::getParams('com_users');
	if ($usersConfig->get('allowUserRegistration') == '0') {
		JError::raiseError( 403, JText::_('ACCESS FORBIDDEN'));
		return;
	}
	
	// Initialize new usertype setting
	$newUsertype = $usersConfig->get('new_usertype');
	if (!$newUsertype) {
		$newUsertype = 'Registered';
	}
	
	// Bind the post array to the user object
	if (!$usern->bind( JRequest::get('post'), 'usertype')) {
		JError::raiseError( 500, $usern->getError());
	}
	
	// Set some initial user values
	$usern->set('id', 0);
	$usern->set('usertype', '');
	$usern->set('gid', $authorize->get_group_id('', $newUsertype, 'ARO'));
	$date =& JFactory::getDate();
	$usern->set('registerDate', $date->toMySQL());
	
	$lang =& JFactory::getLanguage();
 	$lang->load('com_user', JPATH_SITE);

	// If user activation is turned on, we need to set the activation information
	$useractivation = $usersConfig->get('useractivation');
	if ($useractivation == '1')
	{
		jimport('joomla.user.helper');
		$usern->set('activation', JUtility::getHash( JUserHelper::genRandomPassword()) );
		$usern->set('block', '1');
	}
	
	// If there was an error with registration, set the message and display form
	if ( !$usern->save() )
	{
		$msg = JText::_( $usern->getError());
		$link = JRoute::_('index.php?option=com_tpjobs&task=regemployernew');	
		$mainframe->redirect( JRoute::_($link), $msg );
		return false;
	}
	
	
	$userid = $usern->id;

	
	$row->user_id = $userid;
	
	if (!$row->bind( $post )) {
		JError::raiseError(500, $row->getError() );
	}
	

	// pre-save checks
	if (!$row->check()) {
		JError::raiseError(500, $row->getError() );
	}
	
	// save the changes
	if (!$row->store()) {
		JError::raiseError(500, $row->getError() );
	}	
	
	$row->checkin();
	
	tpjobsUploadPhoto($_FILES['photo'], $row->user_id);

	// Send registration confirmation mail
	$password = JRequest::getString('password', '', 'post', JREQUEST_ALLOWRAW);
	$password = preg_replace('/[\x00-\x1F\x7F]/', '', $password); //Disallow control chars in the email
	TPJobSendMail($usern, $password);

	$link	= JRoute::_('index.php?option=com_tpjobs');	
	$mainframe->redirect( JRoute::_($link));
}

/**
==================================================================================================================	
	SECTION : Employer & Job Seeker & Guest
	1.simplesearch
	2.detailJob
	3.detailCompany
	4.detailJobSeeker
==================================================================================================================
*/

//simplesearch
function simpleSearch($option){
	global $mainframe;
	$user	=& JFactory::getUser();
	
	// Check for request forgeries
	//JRequest::checkToken() or jexit('Invalid Token');
	
	// Initialize variables
	$db 	= & JFactory::getDBO();		
	$post   = JRequest::get('post');
	
	$id 	= JRequest::getVar('id', 0, 'get', 'string');

	$id_job_spec = (!empty($post['id_job_spec'])) ?(int) $post['id_job_spec'] : (int) JRequest::getVar('id_job_spec', 0, 'get', 'string');
	$id_country  = (!empty($post['id_country'])) ?(int) $post['id_country'] :(int) JRequest::getVar('id_country', 0, 'get', 'string');
	$keyword  	 = (!empty($post['keyword'])) ? $post['keyword'] : JRequest::getVar('keyword','', 'get', 'string');
	
	$where ="where ( a.job_title like '%".$keyword."%'".
	         " OR a.state like '%".$keyword."%' ".
			 " OR a.city like '%".$keyword."%' ".
			 " OR b.country like '%".$keyword."%' ".			
			 " )";
	
	if($id_job_spec > 0){
		$where .=" and a.id_job_spec =".$id_job_spec;
	}
	
	if($id_country > 0){
		$where .=" and a.id_country =".$id_country;
	}
	$now = date('Y-m-d H:i:s', time() + ( $mainframe->getCfg('offset') * 60 * 60 ) );
	$where.= " and a.is_active='y' and expire_date > '".$now."' and expire_date <> '0000-00-00 00:00:00'";
		
	$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
	
	$limitstart			= JRequest::getVar('limitstart',0,'','int');
	
	
	$query = "SELECT COUNT(*)".	          
			 " from #__tpjobs_job a".
	      	 " left join #__tpjobs_country b".
			 " ON a.id_country = b.country".
		 	 " left join #__tpjobs_employer c".
			 " ON a.employer_id = c.user_id".
			 " left join #__tpjobs_comp_type d".
			 " ON c.id_comp_type = d.id ".$where.
			 " ORDER BY a.publish_date DESC";
			 	
	
	$db->setQuery( $query );
	$total = $db->loadResult();
	
	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );

	$query ="select a.*,country,comp_name,comp_type ".
			 " from #__tpjobs_job a".
	      	 " left join #__tpjobs_country b".
			 " ON a.id_country = b.id".
		 	 " left join #__tpjobs_employer c".
			 " ON a.employer_id = c.user_id".
			 " left join #__tpjobs_comp_type d".
			 " ON c.id_comp_type = d.id ".$where.
			 " ORDER BY a.publish_date DESC";
	
	$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
	
	$rows = $db->loadObjectList();	
	
	HTML_front_tpjobs::simpleSearch($rows,$pageNav,$option);
}


//advsearch
function advSearch($option){
	global $mainframe;
	$user	=& JFactory::getUser();	
	HTML_front_tpjobs::advSearch($option);
}

//resadvsearch
function resAdvSearch($option){
	global $mainframe;
	$user	=& JFactory::getUser();
	
	// Initialize variables
	$db 	= & JFactory::getDBO();		
	$post   = JRequest::get('get');
	$keyword     = (!empty($post['keyword'])) ? $post['keyword'] : null;
	$id_job_spec = (!empty($post['id_js'])) ? $post['id_js'] : null ;
	$id_country  = (!empty($post['id_c'])) ? $post['id_c'] : null ;
	$id_job_exp  = (!empty($post['id_je'])) ? $post['id_je'] : null ;
	$min_salary  = (!empty($post['min_s'])) ? $post['min_s'] : null ;
	$max_salary  = (!empty($post['max_s'])) ? $post['max_s'] : null ;
	$id_salary_type = (!empty($post['id_st'])) ? $post['id_st'] : null ;
			
	$where ="where ( a.job_title like '%".$keyword."%'".
	         " OR a.state like '%".$keyword."%' ".
			 " OR a.city like '%".$keyword."%' ".
			 " OR b.country like '%".$keyword."%' ".			
			 " )";
	
	if(count($id_job_spec) > 0 && !(count($id_job_spec) ==1 && $id_job_spec[0] ==0)){
		$job_spec = implode(',', $id_job_spec );
		$where .=" and a.id_job_spec  IN ( ". $job_spec ." )";
	}
	
	if(count($id_country) > 0 && !(count($id_country) ==1 && $id_country[0] ==0)){
		$country = implode(',', $id_country );
		$where .=" and a.id_country IN ( ". $country ." )";
	}
	
	if(count($id_job_exp) > 0 && !(count($id_job_exp) ==1 && $id_job_exp[0] ==0)){
		$job_exp = implode(',', $id_job_exp );
		$where .=" and a.id_job_exp IN ( ". $job_exp ." )";
	}
	
	if($min_salary >0){
		$where .=" and salary >= ".$min_salary;		
	}
	if($max_salary >0){
		$where .=" and salary <= ".$max_salary;		
	}
	if($id_salary_type > 0){
		$where .=" id_salary_type =".$id_salary_type;
	}
	
	
	$now = date('Y-m-d H:i:s', time() + ( $mainframe->getCfg('offset') * 60 * 60 ) );
	$where.= " and a.is_active='y' and expire_date > '".$now."' and expire_date <> '0000-00-00 00:00:00'";
		
	$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart	= $mainframe->getUserStateFromRequest($option.'.limitstart', 'limitstart', 0, 'int');
	
	
	$query = "SELECT COUNT(*)".	          
			 " from #__tpjobs_job a".
	      	 " left join #__tpjobs_country b".
			 " ON a.id_country = b.country".
		 	 " left join #__tpjobs_employer c".
			 " ON a.employer_id = c.user_id".
			 " left join #__tpjobs_comp_type d".
			 " ON c.id_comp_type = d.id ".$where.
			 " ORDER BY a.publish_date DESC";
			 	
	
	$db->setQuery( $query );
	$total = $db->loadResult();
	
	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );


	$query ="select a.*,country,comp_name,comp_type ".
			 " from #__tpjobs_job a".
	      	 " left join #__tpjobs_country b".
			 " ON a.id_country = b.id".
		 	 " left join #__tpjobs_employer c".
			 " ON a.employer_id = c.user_id".
			 " left join #__tpjobs_comp_type d".
			 " ON c.id_comp_type = d.id ".$where.
			 " ORDER BY a.publish_date DESC";
	
	
	$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );	
	$rows = $db->loadObjectList();	
	
	HTML_front_tpjobs::resAdvSearch($rows,$pageNav,$option);
}

//detailJob
function detailJob($option){
	global $mainframe;
	$user	=& JFactory::getUser();
	$id 	= JRequest::getVar('id', 0, 'get', 'string');

	if(empty($id))
	{
		$return	= JRoute::_('index.php?option=com_tpjobs');
		$mainframe->redirect( $return );	
	}

	$db 	= & JFactory::getDBO();		
	$query = "select a.*,comp_name,degree_level,pos_type,type_salary,g.country,i.industry,e.exp_name from #__tpjobs_job a".
	         " LEFT JOIN #__tpjobs_degree_level b ON a.id_degree_level = b.id".
			 " LEFT JOIN #__tpjobs_pos_type c ON a.id_pos_type = c.id".
			 " LEFT JOIN #__tpjobs_type_salary d ON a.id_salary_type = d.id".
			 " LEFT JOIN #__tpjobs_job_exp e ON a.id_job_exp = e.id".
			 " LEFT JOIN #__tpjobs_job_spec f ON a.id_job_spec = f.id".
			 " LEFT JOIN #__tpjobs_country g ON a.id_country = g.id". 
			 " LEFT JOIN #__tpjobs_employer h ON a.employer_id = h.user_id".
			 " LEFT JOIN #__tpjobs_industry i ON h.id_industry = i.id".
			 " where a.id = ".$id;	
	$db->setQuery( $query);
	
	$data = $db->loadObjectList();
	if(!count($data))
	{
		$return	= JRoute::_('index.php?option=com_tpjobs');
		$mainframe->redirect( $return );	
	}
	
	HTML_front_tpjobs::detailJob($data,$option);
}

//detailCompany
function detailCompany($option){
	global $mainframe;
	$user	=& JFactory::getUser();
	$id 	= JRequest::getVar('id', 0, 'get', 'string');

	if(empty($id))
	{
		$return	= JRoute::_('index.php?option=com_tpjobs');
		$mainframe->redirect( $return );	
	}

	$db 	= & JFactory::getDBO();	
	
	$query = "select a.*,b.email,c.country from #__tpjobs_employer a".
	         " LEFT JOIN #__users b".
			 " on a.user_id = b.id".
			 " LEFT JOIN #__tpjobs_country c".
			 " ON a.id_country = c.id WHERE a.user_id =".$id;
			 ;
	     
	$db->setQuery( $query);
	
	$data = $db->loadObjectList();
	
	if(!count($data))
	{
		$return	= JRoute::_('index.php?option=com_tpjobs');
		$mainframe->redirect( $return );	
	}
	
	HTML_front_tpjobs::detailCompany($data,$option);
	
}

//detailJobSeeker
function detailJobSeeker($option){
	global $mainframe;
	$user	=& JFactory::getUser();
	$id 	= JRequest::getVar('id', 0, 'get', 'string');
	$db 	= & JFactory::getDBO();	

	if(empty($id) OR !$user->id OR (!isJobSeeker($user->id) && !isEmployer($user->id)))
	{
		$return	= JRoute::_('index.php?option=com_tpjobs');
		$mainframe->redirect( $return );	
	}
	
	if($id != $user->id)
	{
		if(isJobSeeker($user->id))
		{
			$return	= JRoute::_('index.php?option=com_tpjobs');
			$mainframe->redirect( $return );	
		}
		
		$query = "SELECT count(*) FROM #__tpjobs_save_job s INNER JOIN #__tpjobs_job j ON s.id_job=j.id WHERE s.jseeker_id=$id AND s.is_apply='y' AND j.employer_id=$user->id";
		$db->setQuery($query);
		if(!$db->loadResult())
		{
			$return	= JRoute::_('index.php?option=com_tpjobs');
			$mainframe->redirect( $return );	
		}
	}
	
	$query = "SELECT a.*, b.email, b.name, m.major, dl.degree_level, pi.industry as primary_industry, si.industry as secondary_industry, pt.pos_type as position_type, ts.type_salary as salary_type FROM #__tpjobs_jobseeker a".
	         " LEFT JOIN #__users b ON a.user_id = b.id".
	         " LEFT JOIN #__tpjobs_major m ON a.id_major = m.id".
	         " LEFT JOIN #__tpjobs_degree_level dl ON a.id_degree_level = dl.id".
	         " LEFT JOIN #__tpjobs_industry pi ON a.id_industry1 = pi.id".
	         " LEFT JOIN #__tpjobs_industry si ON a.id_industry2 = si.id".
	         " LEFT JOIN #__tpjobs_pos_type pt ON a.id_pos_type = pt.id".
	         " LEFT JOIN #__tpjobs_type_salary ts ON a.id_type_salary = ts.id".
					 " WHERE a.user_id =".$id;
			 		 ;

	$db->setQuery( $query);
	$data = $db->loadObjectList();

	if(!count($data))
	{
		$return	= JRoute::_('index.php?option=com_tpjobs');
		$mainframe->redirect( $return );	
	}

	HTML_front_tpjobs::detailJobSeeker($data,$option);
}

//searchBySpec
function searchBySpec($option){
	global $mainframe;
	$user	=& JFactory::getUser();
	$id 	= (int)JRequest::getVar('id', 0, 'get', 'string');
	// Initialize variables
	$db 	= & JFactory::getDBO();		
	
	//for header title
	$query = "select a.id,specialization,category ".
		 		" from #__tpjobs_job_spec a ".
				" left join #__tpjobs_job_categ b".
				" ON a.id_category = b.id".
				" where a.id = ".$id;
				
	$db->setQuery($query);	
	$categ = $db->loadObjectList();
	$spec = $categ[0];
	
	
	$keyword="";
	$where ="where a.job_title like '%".$keyword."%'";
	$where .=" and id_job_spec =".$id." ";
	$now = date('Y-m-d H:i:s', time() + ( $mainframe->getCfg('offset') * 60 * 60 ) );
	$where .= "and a.is_active='y' and expire_date > '".$now."' and expire_date <> '0000-00-00 00:00:00'";
		
	$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
	
	$limitstart			= JRequest::getVar('limitstart',0,'','int');
	
	
	$query = "SELECT COUNT(*)".	          
			 " from #__tpjobs_job a".
	      	 " left join #__tpjobs_country b".
			 " ON a.id_country = b.country".
		 	 " left join #__tpjobs_employer c".
			 " ON a.employer_id = c.user_id".
			 " left join #__tpjobs_comp_type d".
			 " ON c.id_comp_type = d.id ".$where.
			 " ORDER BY a.publish_date DESC";
			 	
	
	$db->setQuery( $query );
	$total = $db->loadResult();
	
	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );


	$query ="select a.*,country,comp_name,comp_type ".
			 " from #__tpjobs_job a".
	      	 " left join #__tpjobs_country b".
			 " ON a.id_country = b.id".
		 	 " left join #__tpjobs_employer c".
			 " ON a.employer_id = c.user_id".
			 " left join #__tpjobs_comp_type d".
			 " ON c.id_comp_type = d.id ".$where.
			 " ORDER BY a.publish_date DESC";
	
	
	$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
	
	$rows = $db->loadObjectList();	
	
	HTML_front_tpjobs::searchBySpec(&$rows,$spec,&$pageNav,$option);
}


//searchByLoc
function searchByLoc($option){
	global $mainframe;
	$user	=& JFactory::getUser();
	
	
	
	$id 	= (int)JRequest::getVar('id', 0, 'get', 'string');
	
	
	// Initialize variables
	$db 	= & JFactory::getDBO();		
	
	
	//for header title
	$query = "select id,country  ".
		 		" from #__tpjobs_country  ".			
				" where id = ".$id;
				
	$db->setQuery($query);	
	$categ = $db->loadObjectList();
	$spec = $categ[0];
	
	
	$keyword="";
	$where ="where a.job_title like '%".$keyword."%'";
	$where .=" and a.id_country =".$id." ";
	$now = date('Y-m-d H:i:s', time() + ( $mainframe->getCfg('offset') * 60 * 60 ) );
	$where .= "and a.is_active='y' and expire_date > '".$now."' and expire_date <> '0000-00-00 00:00:00'";
		
	$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
	
	$limitstart			= JRequest::getVar('limitstart',0,'','int');
	
	
	$query = "SELECT COUNT(*)".	          
			 " from #__tpjobs_job a".
	      	 " left join #__tpjobs_country b".
			 " ON a.id_country = b.country".
		 	 " left join #__tpjobs_employer c".
			 " ON a.employer_id = c.user_id".
			 " left join #__tpjobs_comp_type d".
			 " ON c.id_comp_type = d.id ".$where.
			 " ORDER BY a.publish_date DESC";
			 	
	
	$db->setQuery( $query );
	$total = $db->loadResult();
	
	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );


	$query ="select a.*,country,comp_name,comp_type ".
			 " from #__tpjobs_job a".
	      	 " left join #__tpjobs_country b".
			 " ON a.id_country = b.id".
		 	 " left join #__tpjobs_employer c".
			 " ON a.employer_id = c.user_id".
			 " left join #__tpjobs_comp_type d".
			 " ON c.id_comp_type = d.id ".$where.
			 " ORDER BY a.publish_date DESC";
	
	
	$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
	
	$rows = $db->loadObjectList();	
	
	HTML_front_tpjobs::searchByLoc(&$rows,$spec,&$pageNav,$option);
}

//searchByPosition
function searchByPos($option){
	global $mainframe;
	$user	=& JFactory::getUser();
	
	
	
	$id 	= (int)JRequest::getVar('id', 0, 'get', 'string');
	
	
	// Initialize variables
	$db 	= & JFactory::getDBO();		
	
	
	//for header title
	$query = "select id,pos_type  ".
		 		" from #__tpjobs_pos_type  ".			
				" where id = ".$id;
				
	$db->setQuery($query);	
	$categ = $db->loadObjectList();
	$spec = $categ[0];
	
	
	$keyword="";
	$where ="where a.job_title like '%".$keyword."%'";
	$where .=" and a.id_pos_type =".$id." ";
	$now = date('Y-m-d H:i:s', time() + ( $mainframe->getCfg('offset') * 60 * 60 ) );
	$where .= "and a.is_active='y' and expire_date > '".$now."' and expire_date <> '0000-00-00 00:00:00'";
		
	$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
	
	$limitstart			= JRequest::getVar('limitstart',0,'','int');
	
	
	$query = "SELECT COUNT(*)".	          
			 " from #__tpjobs_job a".
	      	 " left join #__tpjobs_country b".
			 " ON a.id_country = b.id".
		 	 " left join #__tpjobs_employer c".
			 " ON a.employer_id = c.user_id".
			 " left join #__tpjobs_comp_type d".
			 " ON c.id_comp_type = d.id ".
			 " left join #__tpjobs_pos_type e ".
			 " ON  a.id_pos_type = e.id ". $where;
			
			 	
	
	$db->setQuery( $query );
	$total = $db->loadResult();
	
	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );


	$query ="select a.*,country,comp_name,comp_type ".
			 " from #__tpjobs_job a".
	      	 " left join #__tpjobs_country b".
			 " ON a.id_country = b.id".
		 	 " left join #__tpjobs_employer c".
			 " ON a.employer_id = c.user_id".
			 " left join #__tpjobs_comp_type d".
			 " ON c.id_comp_type = d.id ".
			 " left join #__tpjobs_pos_type e ".
			 " ON  a.id_pos_type = e.id ".$where.
			 " ORDER BY a.publish_date DESC";
	
	
	$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
	
	$rows = $db->loadObjectList();	
	
	HTML_front_tpjobs::searchByPos(&$rows,$spec,&$pageNav,$option);
}


//searchByIndustry
function searchByInd($option){
	global $mainframe;
	$user	=& JFactory::getUser();
	
	
	
	$id 	= (int)JRequest::getVar('id', 0, 'get', 'string');
	
	
	// Initialize variables
	$db 	= & JFactory::getDBO();		
	
	
	//for header title
	$query = "select id,industry".
		 		" from #__tpjobs_industry  ".			
				" where id = ".$id;
				
	$db->setQuery($query);	
	$categ = $db->loadObjectList();
	$spec = $categ[0];
	
	
	$keyword="";
	$where ="where a.job_title like '%".$keyword."%'";
	$where .=" and c.id_industry =".$id." ";
	$now = date('Y-m-d H:i:s', time() + ( $mainframe->getCfg('offset') * 60 * 60 ) );
	$where .= "and a.is_active='y' and expire_date > '".$now."' and expire_date <> '0000-00-00 00:00:00'";
		
	$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
	
	$limitstart			= JRequest::getVar('limitstart',0,'','int');
	
	
	$query = "SELECT COUNT(*)".	          
			 " from #__tpjobs_job a".
	      	 " left join #__tpjobs_country b".
			 " ON a.id_country = b.id".
		 	 " left join #__tpjobs_employer c".
			 " ON a.employer_id = c.user_id".
			 " left join #__tpjobs_comp_type d".
			 " ON c.id_comp_type = d.id ". $where;
			
			 	
	
	$db->setQuery( $query );
	$total = $db->loadResult();
	
	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );


	$query ="select a.*,country,comp_name,comp_type ".
			 " from #__tpjobs_job a".
	      	 " left join #__tpjobs_country b".
			 " ON a.id_country = b.id".
		 	 " left join #__tpjobs_employer c".
			 " ON a.employer_id = c.user_id".
			 " left join #__tpjobs_comp_type d".
			 " ON c.id_comp_type = d.id ".
			 " left join #__tpjobs_pos_type e ".
			 " ON  a.id_pos_type = e.id ".$where.
			 " ORDER BY a.publish_date DESC";
	
	
	$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
	
	$rows = $db->loadObjectList();	
	
	HTML_front_tpjobs::searchByInd(&$rows,$spec,&$pageNav,$option);
}




/**
==================================================================================================================	
	SECTION : Additional Function
	1.getSelectCountry
	2.getSelectMajor
	3.getSelectCompType
	4.YesNo
	5.getSalutation
	6.getSelectIndustry
	7.getSelectDegreeLevel
	8.getSelectPositionType
	9.getSelectTypeSalary
	10.getSelectJobSpec
	11.isJobSeeker
	12.isEmployer
	13.getSelectExpLevel
	14.getActiveResume
	15.getSelectPacket
	16.getCreditEmployer
	17.getPacketUsed
	18.countPacketUsed
==================================================================================================================
*/
//getSelectCountry
function getSelectCountry($var,$default,$disabled){
		global $mainframe;
		$db	= & JFactory::getDBO(); 
	
		$option ='';
		if($disabled ==1) 
		$option = 'disabled';
		
		if($default == '') $default = '0'; 
		//make selection country
		$query = 'select id as value, country as text from #__tpjobs_country order by country';		
		$db->setQuery( $query );
		$countries = $db->loadObjectList();
		
		$types[] 		= JHTML::_('select.option',  '0', '- '. JText::_('SELECT COUNTRY') .' -');
		foreach( $countries as $item )
		{
			$types[] = JHTML::_('select.option',  $item->value, JText::_( $item->text ) );
		}		
		
		$lists 	= JHTML::_('select.genericlist',   $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default );
		
		return $lists;

}

//getSelectMajor
function getSelectMajor($var,$default,$disabled){
		
		global $mainframe;
		$db	= & JFactory::getDBO(); 
		
		$option ='';
		if($disabled ==1) 
		$option = 'disabled';
		 
		
		//make selection country
		$query = 'select id as value, major as text from #__tpjobs_major';
		$db->setQuery( $query );
		$users = $db->loadObjectList();
		
		$types[] 		= JHTML::_('select.option',  '0', '- '. JText::_('SELECT MAJOR') .' -');
		foreach( $users as $item )
		{
			$types[] = JHTML::_('select.option',  $item->value, JText::_( $item->text ) );
		}		
		
		$lists 	= JHTML::_('select.genericlist',   $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default );
		
		return $lists;
}


//getSelectCompType
function getSelectCompType($var,$default,$disabled){
		
		global $mainframe;
		$db	= & JFactory::getDBO(); 
		
		$option ='';
		if($disabled ==1) 
		$option = 'disabled';
		 
		
		//make selection country
		$query = 'select id as value, comp_type as text from #__tpjobs_comp_type';
		$db->setQuery( $query );
		$users = $db->loadObjectList();
		
		$types[] 		= JHTML::_('select.option',  '0', '- '. JText::_('SELECT COMPANY TYPE') .' -');
		foreach( $users as $item )
		{
			$types[] = JHTML::_('select.option',  $item->value, JText::_( $item->text ) );
		}		
		
		$lists 	= JHTML::_('select.genericlist',   $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default );
		
		return $lists;
}


//YesNo
function YesNo( $name, $value = 'y')
{
		$put[] = JHTML::_('select.option',  'n', JText::_('NO'));
		$put[] = JHTML::_('select.option',  'y', JText::_('YES'));
		$yesno = JHTML::_('select.radiolist',  $put, $name, '', 'value', 'text', $value );
		return $yesno;
}

//getSalutation
function getSalutation($var,$default,$disabled)
{
		global $mainframe;
		$db	= & JFactory::getDBO(); 
		
		$option ='';
		if($disabled ==1) 
		$option = 'disabled';
		
		//make selection salutation
		$query = 'select id as value, salutation as text from #__tpjobs_salutation';
		$db->setQuery( $query );
		$users = $db->loadObjectList();
		
		$types[] 		= JHTML::_('select.option',  '0', '- '. JText::_('SALUTATION') .' -');
		foreach( $users as $item )
		{
			$types[] = JHTML::_('select.option',  $item->value, JText::_( $item->text ) );
		}		
		
		$lists 	= JHTML::_('select.genericlist',   $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default );
		
		return $lists;
}

//getSelectIndustry
function getSelectIndustry($var,$default,$disabled)
{
		global $mainframe;
		$db	= & JFactory::getDBO(); 
		
		$option ='';
		if($disabled ==1) 
		$option = 'disabled';
		
		//make selection salutation
		$query = 'select id as value, industry as text from #__tpjobs_industry';
		$db->setQuery( $query );
		$users = $db->loadObjectList();
		
		$types[] 		= JHTML::_('select.option',  '0', '- '. JText::_('INDUSTRY') .' -');
		foreach( $users as $item )
		{
			$types[] = JHTML::_('select.option',  $item->value, JText::_( $item->text ) );
		}		
		
		$lists 	= JHTML::_('select.genericlist',   $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default );
		
		return $lists;
}

//getSelectDegreeLevel
function getSelectDegreeLevel($var,$default,$disabled)
{
		global $mainframe;
		$db	= & JFactory::getDBO(); 
		
		$option ='';
		if($disabled ==1) 
		$option = 'disabled';
		
		//make selection salutation
		$query = 'select id as value, degree_level as text from #__tpjobs_degree_level';
		$db->setQuery( $query );
		$users = $db->loadObjectList();
		
		$types[] 		= JHTML::_('select.option',  '0', '- '. JText::_('DEGREE LEVEL') .' -');
		foreach( $users as $item )
		{
			$types[] = JHTML::_('select.option',  $item->value, JText::_( $item->text ) );
		}		
		
		$lists 	= JHTML::_('select.genericlist',   $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default );
		
		return $lists;
}

//getSelectPositionType
function getSelectPositionType($var,$default,$disabled)
{
		global $mainframe;
		$db	= & JFactory::getDBO(); 
		
		$option ='';
		if($disabled ==1) 
		$option = 'disabled';
		
		//make selection salutation
		$query = 'select id as value, pos_type as text from #__tpjobs_pos_type';
		$db->setQuery( $query );
		$users = $db->loadObjectList();
		
		$types[] 		= JHTML::_('select.option',  '0', '- '. JText::_('POSITION TYPE') .' -');
		foreach( $users as $item )
		{
			$types[] = JHTML::_('select.option',  $item->value, JText::_( $item->text ) );
		}		
		
		$lists 	= JHTML::_('select.genericlist',   $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default );
		
		return $lists;
}



//getSelectTypeSalary
function getSelectTypeSalary($var,$default,$disabled)
{
		global $mainframe;
		$db	= & JFactory::getDBO(); 
		
		$option ='';
		if($disabled ==1) 
		$option = 'disabled';
		
		//make selection salutation
		$query = 'select id as value, type_salary as text from #__tpjobs_type_salary';
		$db->setQuery( $query );
		$users = $db->loadObjectList();
		
		$types[] 		= JHTML::_('select.option',  '0', '- '. JText::_('SALARY TYPE') .' -');
		foreach( $users as $item )
		{
			$types[] = JHTML::_('select.option',  $item->value, JText::_( $item->text ) );
		}		
		
		$lists 	= JHTML::_('select.genericlist',   $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default );
		
		return $lists;
}

//getSelectJobSpec
function getSelectJobSpec($var,$default,$disabled)
{
		global $mainframe;
		$db	= & JFactory::getDBO(); 
		
		$option ='';
		if($disabled ==1) 
		$option = 'disabled';
		
		//make selection salutation
		$query = 'select id as value, specialization as text from #__tpjobs_job_spec';
		$db->setQuery( $query );
		$users = $db->loadObjectList();
		
		$types[] 		= JHTML::_('select.option',  '0', '- '. JText::_('JOB SPECIALIZATION') .' -');
		foreach( $users as $item )
		{
			$types[] = JHTML::_('select.option',  $item->value, JText::_( $item->text ) );
		}		
		
		$lists 	= JHTML::_('select.genericlist',   $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default );
		
		return $lists;
}

//isJobSeeker
function isJobSeeker($userid){	
	
	$db =& JFactory::getDBO();
	$query = "SELECT COUNT(*) FROM #__tpjobs_jobseeker where user_id =".$userid;
	
	$db->setQuery( $query );
	$total = $db->loadResult();
	if($total==1){
		return 1;
	}else{
		return 0;
	}
}

//isEmployer
function isEmployer($userid){	
	
	$db =& JFactory::getDBO();
	$query = "SELECT COUNT(*) FROM #__tpjobs_employer where user_id =".$userid;
	
	$db->setQuery( $query );
	$total = $db->loadResult();
	if($total==1){
		return 1;
	}else{
		return 0;
	}
}

//getSelectExpLevel
function getSelectExpLevel($var,$default,$disabled)
{
		global $mainframe;
		$db	= & JFactory::getDBO(); 
		
		$option ='';
		if($disabled ==1) 
		$option = 'disabled';
		
		//make selection salutation
		$query = 'select id as value, exp_name as text from #__tpjobs_job_exp';
		$db->setQuery( $query );
		$users = $db->loadObjectList();
		
		$types[] 		= JHTML::_('select.option',  '0', '- '. JText::_('EXPERIENCE LEVEL') .' -');
		foreach( $users as $item )
		{
			$types[] = JHTML::_('select.option',  $item->value, JText::_( $item->text ) );
		}		
		
		$lists 	= JHTML::_('select.genericlist',   $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default );
		
		return $lists;
}


//getActiveResume
function getActiveResume($jseeker_id){
	global $mainframe;
	$db	= & JFactory::getDBO(); 
	$query = "select id  from #__tpjobs_resume where is_active='y' and jseeker_id=".$jseeker_id;
	$db->setQuery( $query );
	$id = $db->loadResult();
	return $id;
}

//getSelectPacket
function getSelectPacket($var,$default,$disabled,$is_active = 0)
{
		global $mainframe;
		$db	= & JFactory::getDBO(); 
		
		$option ='';
		if($disabled ==1) 
		$option = 'disabled'; 
		
		
		
		//make selection salutation
		if($is_active == 1){
			$query = "select id as value, packet as text,credit from #__tpjobs_packet where is_active ='y'";
		}else{
			$query = "select id as value, packet as text from #__tpjobs_packet";
		}
		$db->setQuery( $query );
		$users = $db->loadObjectList();
		
		$types[] 		= JHTML::_('select.option',  '0', '- '. JText::_('PACKET') .' -');
		foreach( $users as $item )
		{
			$types[] = JHTML::_('select.option',  $item->value, JText::_( $item->text  )." - ".JText::_( $item->credit  )." credit" );
		}		
		
		$lists 	= JHTML::_('select.genericlist',   $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default );
		
		return $lists;
}

//getCreditEmployer
function getCreditEmployer($employer_id){
	global $mainframe;
	$db	= & JFactory::getDBO(); 	
	
	$total_plus =0;
	$total_minus=0;
	
	$query = "select sum(credit_plus) from #__tpjobs_transaction".
			 " where employer_id = ".$employer_id ;
	
	
	$db->setQuery( $query );
	$total_plus = $db->loadResult();
	
	
	
	$query = "select sum(credit_minus) from #__tpjobs_transaction".
			 " where employer_id = ".$employer_id ;
	
	$db->setQuery( $query );
	$total_minus = $db->loadResult();
	
	
	$credit = $total_plus - $total_minus;
	return $credit;
	
			 
}


//getPacketUsed
function getPacketUsed($id_packet,$id_trans){
	global $mainframe;
	$db	= & JFactory::getDBO(); 	
	
	$total_plus =0;
	$total_minus=0;
	
	$query = "SELECT a.id_job,b.job_title  ".
			 " FROM #__tpjobs_packet_use a".
			 " LEFT JOIN #__tpjobs b ".
			 " ON a.id_job = b.id".
			 " WHERE a.id_packet = ".$id_packet.
			 " AND  id_trans = ".$id_trans.
			 " AND id_job <> 0";
			 
	$db->setQuery( $query );
	$jobs = $db->loadObjectList();
    return $jobs;
}

//countPacketUsed
function countPacketUsed($id_packet,$id_trans){
	global $mainframe;
	$db	= & JFactory::getDBO(); 	
	
	$total_plus =0;
	$total_minus=0;
	
	$query = "SELECT COUNT(*)  ".
			 " FROM #__tpjobs_packet_use ".
			 " WHERE id_packet = ".$id_packet.
			 " AND  id_trans = ".$id_trans.
			 " AND id_job <> 0";
		 
	$db->setQuery( $query );
	$total_used = $db->loadResult();
	return $total_used;
}

//getMultipleJobSpec
function getMultipleJobSpec($var,$title,$default,$disabled)
{
		global $mainframe;
		$db	= & JFactory::getDBO(); 
		
		$option ='';
		if($disabled ==1) 
		$option = 'disabled';
		
		//make selection salutation
		$query = 'select id as value, specialization as text from #__tpjobs_job_spec';
		$db->setQuery( $query );
		$users = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option',  '0', '- '. JText::_(''.$title.'') .' -');
		foreach( $users as $item )
		{
			$types[] = JHTML::_('select.option',  $item->value, JText::_( $item->text ) );
		}		
		
		$lists 	= JHTML::_('select.genericlist',   $types, $var, 'class="inputbox" size="5" multiple '.$option.'', 'value', 'text', $default );
		
		return $lists;
}

//getMultipleCountry
function getMultipleCountry($var,$title,$default,$disabled){
		global $mainframe;
		$db	= & JFactory::getDBO(); 
	
		$option ='';
		if($disabled ==1) 
		$option = 'disabled';
		
		if($default == '') $default = '0'; 
		//make selection country
		$query = 'select id as value, country as text from #__tpjobs_country order by country';		
		$db->setQuery( $query );
		$countries = $db->loadObjectList();
		
		$types[] 		= JHTML::_('select.option',  '0', '- '. JText::_(''.$title.'') .' -');
		foreach( $countries as $item )
		{
			$types[] = JHTML::_('select.option',  $item->value, JText::_( $item->text ) );
		}		
		
		$lists 	= JHTML::_('select.genericlist',   $types, $var, 'class="inputbox" size="5" multiple '.$option.'', 'value', 'text', $default );
		
		return $lists;

}

//getMultipletExpLevel
function getMultipleExpLevel($var,$title,$default,$disabled)
{
		global $mainframe;
		$db	= & JFactory::getDBO(); 
		
		$option ='';
		if($disabled ==1) 
		$option = 'disabled';
		
		//make selection salutation
		$query = 'select id as value, exp_name as text from #__tpjobs_job_exp';
		$db->setQuery( $query );
		$exps = $db->loadObjectList();
		
		$types[] 		= JHTML::_('select.option',  '0', '- '. JText::_(''.$title.'') .' -');
		foreach( $exps as $item )
		{
			$types[] = JHTML::_('select.option',  $item->value, JText::_( $item->text ) );
		}		
		
	$lists 	= JHTML::_('select.genericlist',   $types, $var, 'class="inputbox" size="5" multiple '.$option.'', 'value', 'text', $default );
		
		return $lists;
}


//TPJobSendMail
function TPJobSendMail(&$usern, $password)
{
	global $mainframe;

	$lang =& JFactory::getLanguage();
 	$lang->load('com_user', JPATH_SITE);

	$db		=& JFactory::getDBO();

	$name 		= $usern->get('name');
	$email 		= $usern->get('email');
	$username 	= $usern->get('username');

	$usersConfig 	= &JComponentHelper::getParams('com_users');
	$sitename 		= $mainframe->getCfg('sitename');
	$useractivation = $usersConfig->get('useractivation');
	$mailfrom 		= $mainframe->getCfg('mailfrom');
	$fromname 		= $mainframe->getCfg('fromname');
	$siteURL		= JURI::base();

	$subject 	= sprintf ( JText::_('ACCOUNT DETAILS FOR'), $name, $sitename);
	$subject 	= html_entity_decode($subject, ENT_QUOTES);

	if ( $useractivation == 1 ){
		$message = sprintf ( JText::_('SEND MESSAGE FOR ACTIVATION'), $name, $sitename, $siteURL."index.php?option=com_user&task=activate&activation=".$usern->get('activation'), $siteURL, $username, $password);
		
	} else {
		$message = sprintf ( JText::_('SEND MESSAGE'), $name, $sitename, $siteURL);
	}

	$message = html_entity_decode($message, ENT_QUOTES);

	//get all super administrator
	$query = 'SELECT name, email, sendEmail' .
			' FROM #__users' .
			' WHERE LOWER( usertype ) = "super administrator"';
	$db->setQuery( $query );
	$rows = $db->loadObjectList();

	// Send email to user
	if ( ! $mailfrom  || ! $fromname ) {
		$fromname = $rows[0]->name;
		$mailfrom = $rows[0]->email;
	}

	JUtility::sendMail($mailfrom, $fromname, $email, $subject, $message);

	// Send notification to all administrators
	$subject2 = sprintf ( JText::_('ACCOUNT DETAILS FOR'), $name, $sitename);
	$subject2 = html_entity_decode($subject2, ENT_QUOTES);

	$lang =& JFactory::getLanguage();
 	$lang->load('com_user', JPATH_SITE);

	// get superadministrators id
	foreach ( $rows as $row )
	{
		if ($row->sendEmail)
		{
			$message2 = sprintf ( JText::_('SEND_MSG_ADMIN'), $row->name, $sitename, $name, $email, $username);
			$message2 = html_entity_decode($message2, ENT_QUOTES);
			JUtility::sendMail($mailfrom, $fromname, $row->email, $subject2, $message2);
		}
	}
}

function tpjobsUploadPhoto($file, $userid)
{
	//UPLOAD FILE
				
			$config = & JComponentHelper::getParams('com_tpjobs');	
			$allowed = array('image/pjpeg', 'image/jpeg', 'image/jpg', 'image/png', 'image/x-png', 'image/gif', 'image/ico', 'image/x-icon');
			$pwidth  = $config->get('pwidth');
			$pheight = $config->get('pheight');
			$maxsize = $config->get('maxsize');
			
			
			
			if($file['size'] > 0 &&  ($file['size'] / 1024  < $maxsize)){			
			
			if(!file_exists(JPATH_SITE . DS. 'images' . DS . 'tpjobs'))
		    {
		    	if(mkdir(JPATH_SITE . DS . 'images' . DS . 'tpjobs')) {
				    JPath::setPermissions(JPATH_SITE . DS . 'images' . DS . 'tpjobs', '0777');
				    if(file_exists(JPATH_SITE . DS . 'images' . DS . 'index.html')) {
				    	
						copy(JPATH_SITE . DS . 'images' . DS . 'index.html', JPATH_SITE . DS . 'images' . DS . 'tpjobs/index.html');
				    }
				  }
		    }
		   
				if($file['error'] != 0){
					echo "<script> alert('Upload file photo error.'); window.history.go(-1); </script>\n";
					exit ();
				}
				
				if($file['size'] == 0){
					$file = null;
				}
				
		 		if(!in_array($file['type'], $allowed)) {
					$file = null;
		 		}
				
				if ($file != null){
					$dest = JPATH_SITE.DS.'images'.DS.'tpjobs'.DS.$userid.'.jpg';
					
					
					if(file_exists($dest))
					{
						unlink($dest);
					}
					$soure = $file['tmp_name'];
					jimport('joomla.filesystem.file');
					$uploaded = JFile::upload($soure,$dest);
		
					$fileAtr = getimagesize($dest);
					$widthOri = $fileAtr[0];
					$heightOri = $fileAtr[1];
					$type = $fileAtr['mime'];
				  $img = false;
				  switch ($type)
				  {
				    case 'image/jpeg':
				    case 'image/jpg':
				    case 'image/pjpeg':
				      $img = imagecreatefromjpeg($dest);					 
				      break;
				    case 'image/ico':
				      $img = imagecreatefromico($dest);
				      break;
				    case 'image/x-png':
				    case 'image/png':
				      $img = imagecreatefrompng($dest);
				      break;
				    case 'image/gif':
				      $img = imagecreatefromgif($dest);
				      break;
				  }
				  
				  if(!$img)
				  {
				    return false;
				  }
				    
				  $curr = @getimagesize($dest);
				    
				  $perc_w = $pwidth / $widthOri;
				  $perc_h = $pheight / $heightOri;
				  if(($widthOri<$pwidth) && ($heightOri<$height))
				  {
				    return;
				  }
				
				  if($perc_h > $perc_w)
				  {
				  	$pwidth = $pwidth;
				    $pheight = round($heightOri * $perc_w);
				  }
				  else 
				  {
				    $pheight = $pheight;
				    $pwidth = round($widthOri * $perc_h);
				  }
				  
				 
				  $nwimg = imagecreatetruecolor($pwidth, $pheight);
				  imagecopyresampled($nwimg, $img, 0, 0, 0, 0, $pwidth, $pheight, $widthOri, $heightOri);
				    	
				  imagejpeg($nwimg, $dest, 100);
				  imagedestroy($nwimg);
				  imagedestroy($img);
				} 	
				
			}else{
				if($file['size'] / 1024  > $maxsize){
					echo "<script> alert('Size of file photo is too big. Maximum size".$maxsize." KB'); window.history.go(-1); </script>\n";
					exit ();
				}
			
			}
}

function invoice($option)
{
	$user	=& JFactory::getUser();
	$id 	= JRequest::getVar('id', 0, 'get', 'string');
	$db 	= & JFactory::getDBO();	

	if(empty($id) OR !$user->id OR (!isJobSeeker($user->id) && !isEmployer($user->id)) OR isJobSeeker($user->id))
	{
		$return	= JRoute::_('index.php?option=com_tpjobs');
		$mainframe->redirect( $return );	
	}
	
	$query = "SELECT count(*) FROM #__tpjobs_billing WHERE id=$id AND employer_id=$user->id";
	$db->setQuery($query);
	if(!$db->loadResult())
	{
		?>
		<script language="javascript" type="text/javascript">
		window.close();
		</script>
		<?php
	}
	else
	{
		$query = "SELECT b.*, u.email, e.*, c.country FROM #__tpjobs_billing b LEFT JOIN #__users u ON b.employer_id=u.id LEFT JOIN #__tpjobs_employer e ON e.user_id=u.id LEFT JOIN #__tpjobs_country c ON b.id_country=c.id WHERE b.id=$id AND b.employer_id=$user->id";
		$db->setQuery($query);
		$row = $db->loadObject();
		HTML_front_tpjobs::printInvoice($row);
	}
}

// Plese do not remove these following powered text and link
// <!-- start
echo '<div align="center">';
echo 'Powered By TPJobs - <a href="http://templateplazza.com" target="_blank">Joomla Jobs Directory Component</a>';
echo '</div>';
// end -->

?>
